// "use strict";
// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic','configImport','importController', 'configPublic','publicController','starter.controllers','classeController','groupeController','baladoDirectives','consigneController','magnetoController','tutoController','inscription',"wikiModul"])

.run(function($ionicPlatform) {
  $ionicPlatform.ready(function() {
     
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      cordova.plugins.Keyboard.disableScroll(true);
      
    }
    if (window.cordova && cordova.plugins.Keyboard.hideKeyboardAccessoryBar) {
    cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
}
      
      // var networkState = navigator.connection.type;
      
      // console.info("networkState",networkState)
    
    if (ionic.Platform.isAndroid() || ionic.Platform.isIOS()) {
      // org.apache.cordova.statusbar required
      //StatusBar.styleDefault();
      StatusBar.hide();
    }
  });
})

.config(function($stateProvider, $urlRouterProvider,$windowProvider) {

  $stateProvider

   

    .state('app', {
    url: '/app',
    abstract: true,
    templateUrl: 'templates/menu.html',

    
  })

  .state('app.inscription', {
    url: '/inscription/:rne/:activation',
    views: {
      'menuContent': {
        templateUrl: 'templates/inscription.html',
        controller: 'ctrlInscription'
      }
    }
  })

  .state('app.mdp', {
    url: '/mdp/:activation',
    views: {
      'menuContent': {
        templateUrl: 'templates/mdp.html',
        controller: 'ctrlMdp'
      }
    }
  })
   .state('app.mdpeleve', {
    url: '/mdpeleve/:id',
    views: {
      'menuContent': {
        templateUrl: 'templates/mdpeleve.html',
        controller: 'ctrlMdpeleve'
      }
    }
  })

  .state('app.activation', {
    url: '/activation/:code',
    views: {
      'menuContent': {
        templateUrl: 'templates/activation.html',
        controller: 'ctrlActivation'
      }
    }
  })

     .state('app.tuto', {
    url: '/tuto',
    views: {
      'menuContent': {
        templateUrl: 'templates/tuto/tuto.html',
        controller: 'ctrlVideo'
      }
    }
  })

.state('app.home', {
    url: '/home/:rne',
    views: {
      'menuContent': {
        templateUrl: 'templates/home.html',
        controller: 'ctrlApp'
      }
    }
  })

     .state('app.etablissement', {
    url: '/etablissement/:id',
    views: {
      'menuContent': {
        templateUrl: 'templates/etablissement.html',
        controller: 'ctrlEtab'
      }
    }
  })


   .state('app.authcas', {
    url: '/authcas/:rne/:token',
    views: {
      'menuContent': {
        templateUrl: 'templates/authcas.html',
        controller: 'ctrlAuthcas'
      }
    }
  })

    .state('app.activites', {
    url: '/activites',
    views: {
      'menuContent': {
        templateUrl: 'templates/activites.html',
        controller:'ctrlActivites'
      }
    }
  })


.state('app.consigne_vue', {
    url: '/consigne/:id/vue',
    views: {
      'menuContent': {
        templateUrl: 'templates/consigne_vue.html',
        controller:"ctrlConsigne"
      }
    }
  })

.state('app.consigne_magneto', {
    url: '/consigne/:id/magneto',
    views: {
      'menuContent': {
        templateUrl: 'templates/consigne_magneto.html',
        controller:"ctrlConsigne"
      }
    }
  })

.state('app.docs', {
    url: '/docs/:id',
    views: {
      'menuContent': {
        templateUrl: 'templates/modales/docs.html',
        controller:"ctrlConsigne"
      }
    }
  })

.state('app.wikidata', {
    url: '/wikidata/:id',
    views: {
      'menuContent': {
        templateUrl: 'templates/modales/wikidata.html',
        controller:"ctrlConsigne"
      }
    }
  })

.state('app.consigne_edit', {
    url: '/consigne/:id/edit',
    views: {
      'menuContent': {
        templateUrl: 'templates/consigne_edit.html',
        controller:"ctrlConsigne",
       
      }
    }
  })
.state('app.consigne_reponses', {
    url: '/consigne/:id/reponses',
    views: {
      'menuContent': {
        templateUrl: 'templates/consigne_reponses.html',
        controller:"ctrlConsigne",
        params: {
          'publier': 'O', 
          
        }
      }
    }
  })
.state('app.reponse', {
    url: '/reponse/:id',
    views: {
      'menuContent': {
        templateUrl:  'templates/reponse.html',
        controller:"ctrlReponse"
      }
    }
  })
.state('app.consigne_partage', {
    url: '/consigne/:id/partage',
    views: {
      'menuContent': {
        templateUrl: 'templates/consigne_partage.html',
        controller:"ctrlConsigne"
      }
    }
  })
  .state('app.consigneEleve', {
    url: '/consigneEleve/:id',
    views: {
      'menuContent': {
        templateUrl: 'templates/consigne_vue_eleve.html',
         controller:"ctrlConsigne"
      }
    }
  })
  .state('app.consigneEleve2', {
    url: '/consigneEleve2/:id',
    views: {
      'menuContent': {
        templateUrl: 'templates/consigne_vue_eleve_2panes.html',
         controller:"ctrlConsigne",
        
      }
    }
  })


  .state('app.moncompte', {
    url: '/moncompte',
    views: {
      'menuContent': {
        templateUrl: 'templates/mon_compte.html',
        controller: 'ctrlApp',
      }
    }
  })

.state('app.voireleves', {
    url: '/voireleves',
    views: {
      'menuContent': {
        templateUrl: 'templates/voir_eleves.html',
        controller: 'ctrlEleves',
        
      }
    }
  })

.state('app.gestioneleves', {
    url: '/gestioneleves',
    views: {
      'menuContent': {
        templateUrl: 'templates/gestion_eleves.html',
        controller: 'ListeClasses',
        controller: 'ListeGroupes',
        controller: 'ListeGroupesprives',
        controller: 'ctrlPopup'
      }
    }
  })
  
  .state('app.aide', {
    url: '/aide',
    views: {
      'menuContent': {
        templateUrl: 'templates/aide.html'
      }
    }
  })
 
  .state('app.deconnect', {
    url: '/deconnect',
    views: {
      'menuContent': {
        templateUrl: 'templates/deconnection.html'
      }
    }
  })




.state('app.gererclasse', {
    url: '/gererclasse',
    views: {
      'menuContent': {
        templateUrl: 'templates/gerer_classe.html',
        controller: 'ctrlListeClasses',
      }
    }
  })


.state('app.gerergroupe', {
    url: '/gerergroupe',
    views: {
      'menuContent': {
        templateUrl: 'templates/gerer_groupe.html',
        controller: 'ctrlListeGroupes',
      }
    }
  })

.state('app.gerergroupeedition', {
    url: '/gerergroupeedition/:id',
    views: {
      'menuContent': {
        templateUrl: 'templates/gerer_groupe_edition.html',
        controller: 'ctrlListeEleves',
      }
    }
  }) 

  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/app/home');
})

.config( [
    '$compileProvider',
    function( $compileProvider )
    {   
        $compileProvider.aHrefSanitizationWhitelist(/^\s*(https?|file|itpc):/);


        // Angular before v1.2 uses $compileProvider.urlSanitizationWhitelist(...)
    }

    
])
.config( 
    
    function( $ionicConfigProvider )
    {   
       var isMobile=ionic.Platform.isIOS() || ionic.Platform.isAndroid();
      $ionicConfigProvider.scrolling.jsScrolling(isMobile)
        // Angular before v1.2 uses $compileProvider.urlSanitizationWhitelist(...)
    }

    
);


function handleOpenURL(url) {

    var body = document.getElementsByTagName("body")[0];
    var ctrlApp = angular.element(body).scope();
    ctrlApp.reportAppLaunched(url);

}
