angular.module('classeController', ['baladoServices', 'ngStorage'])
///////////////////////////////////////////////////
///////////////////////////////////////////////////
// RECUPERATION DES CLASSES DE L'ETABLISSEMENT
///////////////////////////////////////////////////
///////////////////////////////////////////////////

.controller('ctrlEleves', function($rootScope, $scope, getData, deleteData, $location, $sessionStorage, $state, $ionicHistory, postData, $localStorage) {
    if($sessionStorage.profil.auth=='sconet'){
        $scope.modifMdp=true;
    }
   $rootScope.$on('$stateChangeStart',function(event, toState, toParams, fromState, fromParams){    
      if(toState.name=='app.voireleves'){  
        $scope.actualiseMesEleves();
        
       }
    })


    $scope.actualiseMesEleves=function(){
        getData.fromUrl("elevesclasse/rne/"+ $sessionStorage.profil.rne).then(function(json) {
                $scope.classes={};
                console.info(json)
                angular.forEach($sessionStorage.profil.classes, function(value, key) {
                     $scope.classes[key]=angular.copy($sessionStorage.profil.classes[key]);
                     $scope.classes[key].eleves=json.data.datas[key];
                })
                 
            })
    }

    $scope.initMdp=function(eleve){
       console.info("init",eleve);

        postData.async("mdpeleve/"+eleve.id,{'init':true}).then(function(json) { 
        console.info("go")
        console.info(json.data);
          if(json.data.datas){
            
             
             eleve.mdp=false
             console.info(json.data.datas)
          }
      })
    }

    $scope.actualiseMesEleves();       
})

.controller('ctrlListeClasses', function($rootScope, $scope, getData, deleteData, $location, $sessionStorage, $state, $ionicHistory, postData, $localStorage) {
    if ($sessionStorage.profil.role == "prof") 
    {
        var touteslesclasses = [];
        var classesduprof = [];
        var classespasduprof = [];
        var cpt = 0;
        var checkouinon = [];
        // On récupère la liste des classes du prof
        getData.fromUrl("prof/" + $sessionStorage.profil.id).then(function(json) {
            $scope.classesduprof = json.data.datas.classes;
             console.info( "$scope.classesduprof", $scope.classesduprof)
            }).then(function() {
                getData.fromUrl("etablissement/rne/" + $sessionStorage.profil.rne).then(function(json) {
                    // On récupère toutes les classes de l'établissement
                    $scope.touteslesclasses = json.data.datas.classes;
                   
                    // On garde une copie de toutes les classes de l'établissement
                    // On parcourt toutes les classes de l'établissement
                    angular.forEach($scope.touteslesclasses, function(value, key) {
                    if ($scope.classesduprof[key]) 
                    {
                         value.checked = true;
                    } 
                    else 
                    {
                        value.checked = false;
                    }
                })
            })
        })

    }
    $scope.saveClasse = function(item) {
    postData.async("elevesclasse/id_classe/" + item.id,item).then(function(json) {
        console.info("eleves classe",json)
    })
    var datas = {};
    var compteur = 0;
    datas.id_prof = $sessionStorage.profil.id;
    datas.id_classe = item.id;
    // Si la classe était checked,...
    if (item.checked == true) 
    {
        // On récupère tous les partages du prof   
        getData.fromUrl("partages/id_prof/" + $sessionStorage.profil.id).then(function(json) 
        {
            for (partage in json.data.datas) 
            {   // On ne garde que les classes
                if (json.data.datas[partage].type_ensemble == "classe") 
                {   // On compte le nb de partages en cours avec cette classe
                    if (json.data.datas[partage].id_ensemble == item.id)
                    {
                        compteur++;
                    }
                }
            }
            // S'il y a 1 partage, pas de suppression, message d'erreur
            if (compteur == 1) 
            {
                $scope.touteslesclasses[item.id].checked = true
                $scope.touteslesclasses[item.id]['info'] = "--> Il faut d'abord supprimer le partage en cours avec cette classe.";
            }
            // S'il y a plusieurs partages, pas de suppression, message d'erreur
            else if (compteur > 1) 
            {
                $scope.touteslesclasses[item.id].checked = true
                $scope.touteslesclasses[item.id]['info'] = "--> Il faut d'abord supprimer les " + compteur + " partages en cours avec cette classe.";
            }
            // S'il n'y a pas de partages, on supprime
            else
            {   //...alors on la unchecked
                item.checked = false;
                //...et on supprime la liaison prof-classe
                deleteData.fromUrl("classes/" + datas.id_classe).then(function(json) 
                {   delete $sessionStorage.profil.classes[datas.id_classe];
                    console.info("delete", $sessionStorage.profil.classes)
                    $localStorage.consigne = "reload";
                });
            }
        })
    }
    // Si la classe n'était pas checked,...    
    else
    {   //...alors on la checked
        item.checked = false;
        //...et on ajoute la liaison prof-classe
        postData.async("classes/" + datas.id_classe, datas).then(function(json) 
        {   $sessionStorage.profil.classes[datas.id_classe] = $scope.touteslesclasses[datas.id_classe];
            console.info("$sessionStorage.profil.classes",$sessionStorage.profil.classes)
            $localStorage.consigne = "reload";
        });
    }
    $scope.classesduprof=$sessionStorage.profil.classes
    return item;
}
})