angular.module("consigneController", [ "angularAudioRecorder", "baladoServices", "ui.tinymce","ionic-datepicker" ])

.controller("ctrlConsigne", [ "$rootScope", "$scope", "$state", "$stateParams", "getData","pageExist", "postData", "getBlob", "$sanitize", "$sessionStorage", "$filter", "deleteData", "$ionicHistory", "getDataEmbed", "$sce", "uploadData", "HOST", "HOSTAPP", "$ionicTabsDelegate", "$localStorage", "$ionicModal", "$sceDelegate", "FILE", "FILEACONVERTIR", "$timeout", "$ionicPopup","ionicDatePicker","STRING", function($rootScope, $scope, $state, $stateParams, getData,pageExist, postData, getBlob, $sanitize, $sessionStorage, $filter, deleteData, $ionicHistory, getDataEmbed, $sce, uploadData, HOST, HOSTAPP,$ionicTabsDelegate, $localStorage, $ionicModal, $sceDelegate, FILE, FILEACONVERTIR, $timeout, $ionicPopup,ionicDatePicker,STRING) {
    $scope.rootItpc = HOST.replace("http", "itpc");

    var ipObj1 = {
      callback: function (val) {  //Mandatory
        var newDate=$filter('date')(new Date(val),'yyyy-MM-dd');
        angular.element("#"+ipObj1.champ+ipObj1.partage.id).val(newDate);
        ipObj1.partage[ipObj1.champ]=new Date(val);
        $scope.savePartage(ipObj1.partage)
      },
      closeLabel: 'Fermer',
      weeksList: ["D", "L", "M", "M", "J", "V", "S"],
      monthsList: ["Jan", "Fev", "Mars", "Avril", "Mai", "Juin", "Juil", "Aout", "Sept", "Oct", "Nov", "Dec"],
      closeOnSelect: true,       //Optional
      templateType: 'popup' ,      //Optional
     
    };

   $scope.openDatePicker = function(partage,champ){
        ipObj1.inputDate=partage[champ];
        ipObj1.partage=partage;
        ipObj1.champ=champ;
        ionicDatePicker.openDatePicker(ipObj1)
    };


    if ($sessionStorage.profil.role) {
        $rootScope.profil = $sessionStorage.profil;
        $scope.activite = {};
    }
    if ($rootScope.isAndroid) {
        $scope.androidAlertInfo = "androidAlertInfo";
    } else {
        $scope.androidAlertInfo = "";
    }
    $scope.$on("alertInfo", function(event, data) {
        $scope.alertInfo = data.text;
        $scope.color = data.color;
        $scope.alertInfoAction = data.action;
    });
    $scope.$on("deleteSound", function(event, data) {
        if (data.data.datas.id_eleve) {
            delete $scope.activite.reponse.medias;
        }
        if (data.data.datas.id_prof) {
            delete $scope.activite.medias;
        }
    });
    var profil = $rootScope.profil.role == "prof" ? "" : "Eleve";
    $scope.voirMagneto = true;
    $rootScope.$on("$stateChangeStart", function(event, toState, toParams, fromState, fromParams) {
        if (toState.name == "app.consigneeleve_magneto" || toState.name == "app.consigne_magneto" || toState.name == "app.consigne_edit" || toState.name == "app.consigneEleve") {
            if (toParams.id == $stateParams.id) {
                $scope.loadConsigne();
            }
            $localStorage.consigne = "off";
        }
       
        if ($scope.activite.id==fromParams.id && toState.name == "app.activites" && fromState.name=="app.consigne_edit" && $scope.activite.titre=="") { 
            console.info("TITRE!!");
            $scope.titreAbsent($scope.activite.id);
        }
      
       
    });
    $scope.loadConsigne = function() {
        
        getData.fromUrl("consigne" + profil + "/" + $stateParams.id).then(function(json) {
            $scope.activite = json.data.datas;
            console.info( "activite0",$scope.activite)
            var ac = {
                1: true,
                0: false
            };
            
            var id_public = json.data.datas["public"];
            var id_archive = json.data.datas["archive"];
            $scope.activite.public = ac[id_public];
            $scope.activite.archive = ac[id_archive];
            if ($scope.activite.text == "<br>") {
                $scope.activite.text = "";
            }
            if ($scope.activite.text && $scope.activite.text != "" && $scope.activite.text.indexOf("<p>") < 0) {
                $scope.activite.text = "<p>" + $scope.activite.text + "</p>";
            }
            $scope.$emit("activite", $scope.activite);
            $scope.id = $scope.activite.id;
            $scope.partages = $scope.activite.partages;
            //#######################################
            //################## PROF ###############
            //#######################################
            if ($sessionStorage.profil.role == "prof") {

                var titre=$("<div>"+$scope.activite.titre+"</div>").html();
                $scope.activite.titre=titre;
                
                //Creation consigne : 1er enregistrement
                $scope.$on("newMedia", function(event, data) {
                    if(data){
                        $scope.activite.medias = [];
                        $scope.activite.medias[0] = data;
                    }
                    else{
                       delete($scope.activite.medias);
                    }
                    
                });
                if ($rootScope.isWebView && $scope.activite.medias) {
                    var blobChemin = $scope.activite.medias[0].chemin.replace("wav", "mp3");
                    var alea = Math.random();
                    getBlob.fromUrl(blobChemin + "?" + alea).then(function(json) {
                        // $scope.prefix='consigne';
                        $scope.id_media = $scope.activite.medias[0].id;
                        if (!$scope.recorded) {
                            $scope.recorded = [];
                        }
                        $scope.recorded[$stateParams.id] = json.data;
                        $scope.$emit("recorded", $scope.recorded);
                    });
                }
                if (!$rootScope.isWebView && $scope.activite.medias) {
                    $scope.recorded[$stateParams.id] = $scope.activite.medias[0].chemin;
                    $scope.soundToPlay = $scope.activite.medias[0].chemin;
                    $scope.$emit("recorded", $scope.recorded);
                }
                var uploads = {};
                angular.forEach($scope.activite.uploads, function(upload, key) {
                    uploads[upload.id] = upload;
                });
                $scope.activite.uploads = {};
                $scope.activite.uploads = uploads;
                //console.info("uploads",$scope.activite.uploads)
                getData.fromUrl($sessionStorage.profil.role + "/" + $sessionStorage.profil.id).then(function(json) {
                    $scope.classes = json.data.datas.classes;
                    $scope.groupes = json.data.datas.groupes;
                    $scope.listePartages = $scope.createListePartages($scope.classes, $scope.groupes, $scope.partages);
                });
                $scope.cptrep = 0;
                $scope.cpttotal = 0;
                $scope.cptencours = 0;
            }
            //#######################################
            //################## ELEVE ###############
            //#######################################
            if ($sessionStorage.profil.role == "eleve") {

                $scope.datedujour=Date.now();
                if(!$scope.activite.partage.date_fin){
                    $scope.datefin=$scope.datedujour+24*60*60*1000;
                    console.info("date N1",$scope.datedujour+" "+$scope.activite.partage.date_fin)
                }
                else{
                    $scope.datefin=new Date($scope.activite.partage.date_fin).getTime()+24*60*60*1000;
                    console.info("date Y1",$scope.datedujour+" "+$scope.activite.partage.date_fin)
                }   
                
                if ($scope.activite.reponse && $scope.activite.reponse.publier == "O") {
                    $scope.$emit("rendre", true);
                }
                $scope.prefixPlayer = "consigne";
                $scope.prefixMagneto = "reponse";
                $scope.$on("newMedia", function(event, data) {
                    if(data){
                        $scope.activite.reponse.medias = [];
                        $scope.activite.reponse.medias[0] = data;
                    }
                    else{
                        delete($scope.activite.reponse.medias);
                    }
                    
                });
                if (!$rootScope.isWebView && $scope.activite.medias) {
                    $scope.soundToPlay = $scope.activite.medias[0].chemin;
                    $scope.$emit("recorded", $scope.soundToPlay);
                }
                if (!$scope.activite.reponse) {
                    if (!$scope.activite.id) {
                        return;
                    }
                    var postDatas = {};
                    postDatas.id_consigne = $scope.activite.id;
                    $scope.activite.reponse = {};
                    postData.async("reponse", postDatas).then(function(json) {
                        $scope.activite.reponse.id = json.data.datas.resultat.id;
                    });
                } else {
                    if ($scope.activite.reponse.medias && $rootScope.isWebView) {
                        var blobChemin = $scope.activite.reponse.medias[0].chemin.replace("wav", "mp3");
                        var alea = Math.random();
                        getBlob.fromUrl(blobChemin + "?" + alea).then(function(json) {
                            $scope.recorded[$stateParams.id] = json.data;
                            $scope.$emit("recorded", $scope.recorded);
                        });
                    } else if ($scope.activite.reponse.medias && !$rootScope.isWebView) {
                        $scope.recorded[$stateParams.id] = $scope.activite.reponse.medias[0].chemin;
                        $scope.$emit("recorded", $scope.recorded);
                    }
                    var uploadsEleve = {};
                    angular.forEach($scope.activite.reponse.uploads, function(upload, key) {
                        uploadsEleve[upload.id] = upload;
                    });
                    $scope.activite.reponse.uploads = {};
                    $scope.activite.reponse.uploads = uploadsEleve;
                }
            }
        }).then(function() {
            
            if($scope.activite=='acces interdit' || !$scope.activite.id){
                $state.go("app.activites")
            }
            if ($sessionStorage.profil.role == "eleve") {
                console.info("&ctivite",$scope.activite);
                $scope.datedujour=Date.now();
                if(!$scope.activite.partage.date_fin){
                    $scope.datefin=$scope.datedujour+24*60*60*1000;
                    console.info("date No 2",$scope.datedujour+" "+$scope.activite.partage.date_fin)
                }
                else{
                    $scope.datefin=new Date($scope.activite.partage.date_fin).getTime()+24*60*60*1000;
                     console.info("date Y 2",$scope.datedujour+" "+$scope.datefin)
                }   
                
                

            }
            
            
            $sessionStorage.activite = $scope.activite;
            $scope.$broadcast("scroll.refreshComplete");
           

        });
    };
    $scope.loadConsigne();
    $scope.initPartage = function(partage) {
        partage.date_deb = new Date(partage.date_deb * 1e3);
        partage.date_fin = new Date(partage.date_fin * 1e3);
        partage.text = partage.titre_ensemble;
        partage.ref = partage.type_ensemble + partage.id_ensemble;
        partage.idRef = partage.id;
        parseInt(partage.publier) > 0 ? partage.checked = true : partage.checked = false;
        return partage;
    };
    $scope.initEnsemble = function(ensemble) {
        ensemble.checked = false;
        if (ensemble.classe) {
            ensemble.titre_ensemble = ensemble.classe;
            ensemble.type_ensemble = "classe";
            ensemble.ref = "classe" + ensemble.id;
        } else {
            ensemble.titre_ensemble = ensemble.libelle;
            ensemble.type_ensemble = "groupe";
            ensemble.ref = "groupe" + ensemble.id;
        }
        ensemble.date_deb = new Date();
        var date_fin = new Date();
        date_fin.setDate(date_fin.getDate() + 7);
        ensemble.date_fin = date_fin;
        ensemble.id_ensemble = ensemble.id;
        ensemble.id_consigne = $scope.activite.id;
        delete ensemble.id;
        return ensemble;
    };
    $scope.createListePartages = function(classes, groupes, partages) {
        var listePartages = {};
        angular.forEach(classes, function(classe, keyc) {
            angular.forEach(partages, function(partage, key) {
                if (classe.id == partage.id_ensemble && partage.type_ensemble == "classe") {
                    partage = $scope.initPartage(partage);
                    delete classes[keyc];
                    listePartages[partage.ref] = partage;
                }
            });
        });
        //ajout des classes ne faisant pas l'objet d'un partage 
        //à la liste des partages
        angular.forEach(classes, function(classe, keyc) {
            classe = $scope.initEnsemble(classe);
            listePartages[classe.ref] = classe;
        });
        //ajout des groupes concernées par le partage à la liste des partages
        //suppression des groupes concernés par le partage de la liste des groupes
        angular.forEach(groupes, function(groupe, keyg) {
            angular.forEach(partages, function(partage, keyp) {
                if (groupe.id == partage.id_ensemble && partage.type_ensemble == "groupe") {
                    partage = $scope.initPartage(partage);
                    delete groupes[keyg];
                    listePartages[partage.ref] = partage;
                }
            });
        });
        //ajout des groupes ne faisant pas l'objet d'un partage 
        //à la liste des partages
        angular.forEach(groupes, function(groupe, keyg) {
            groupe = $scope.initEnsemble(groupe);
            listePartages[groupe.ref] = groupe;
        });
        //console.info("listePartages",listePartages)
        return listePartages;
    };
    $scope.showConfirmDeleteConsigne = function(id) {
        var confirmPopup = $ionicPopup.confirm({
            title: "Attention !",
            template: "Une fois supprimée, vous ne pourrez plus accéder à cette consigne, ni aux éventuelles réponses.",
            cancelText: "Annuler",
            okText: "Supprimer"
        });
        confirmPopup.then(function(res) {
            if (res) {
                $scope.deleteConsigne(id);
            }
        });
    };
    $scope.deleteConsigne = function(id) {
        deleteData.fromUrl("consigne/" + id).then(function(json) {
            //console.info(json);
            $scope.$emit("consigne", id);
            $scope.go("app.activites", null);
        });
    };
    $scope.saveConsigne = function() {
        console.info("save", $scope.activite);
        var datas = {};
        datas.id = $scope.activite.id;
        var encoded = $sce.getTrustedHtml($scope.activite.titre);
        datas.titre = $scope.activite.titre;
        datas.text = $scope.activite.text;
        datas.public = $scope.activite.public;
        datas.archive = $scope.activite.archive;
        
        return postData.async("consigne/" + datas.id, datas).then(function(json) {
          console.info(json.data)
          if(json.data.datas.id){
            $scope.$emit("consigne", $scope.activite);
          }
          else{
            console.info("false")
            $scope.alertMessage("Modification impossible","red","none")
             $timeout(function(){
                            $scope.alertMessage("","red","none");
                },2500)
            $scope.loadConsigne($scope.activite.id);

          }
           

        });
    };
    $scope.saveReponse = function(item) {
        //console.info("item",item)
        if (item.medias) {
            delete item.medias;
        }
        if (item.uploads) {
            delete item.uploads;
        }
        if (item.eleve) {
            delete item.eleve;
        }
        if (!item.publier) {
            item.publier = "N";
        }
        item.date = new Date();
        return postData.async("reponse/" + item.id, item).then(function(json) {
            //console.info("retour POST",json);
            $scope.loadConsigne();
        });
    };
    $scope.showConfirmPartage = function(item, bilan) {
        var encours = bilan.encours > 0 ? bilan.encours + " réponses en cours de rédaction.<br>" : "";
        var rendu = bilan.rendu > 0 ? bilan.rendu + " réponses en cours de rédaction.<br>" : "";
        var texte = "Si vous confirmez vos élèves ne pourront plus accéder à votre consigne.";
        var confirmPopup = $ionicPopup.confirm({
            title: "Attention !",
            template: encours + rendu + texte,
            cancelText: "Annuler",
            okText: "confirmer"
        });
        confirmPopup.then(function(res) {
            if (res) {
                console.log("Bouton RENDRE choisi");
                $scope.savePartage(item);
            } else {
                console.log("Bouton ANNULER choisi");
                item.checked = true;
            }
        });
    };
    $scope.addRemovePartage = function(item) {
        if (item.checked) {
            delete item.id;
            $scope.savePartage(item);
        } else {
            getData.fromUrl("partages/" + item.id).then(function(json) {
                var bilan = json.data.datas[item.id].bilan;
                if (bilan.encours > 0 || bilan.rendu > 0) {
                    $scope.showConfirmPartage(item, bilan);
                }
                else{
                    $scope.savePartage(item);
                }
            });
        }
    };
    $scope.savePartage = function(item, index) {
        var index = index || null;
        var datas = {};
        if (!item.id) {
            var id = "";
        } else {
            datas.id = item.id;
            var id = datas.id;
        }
        if (!item.checked) {
            datas.publier = 0;
        } else {
            datas.publier = 1;
        }
        
        datas.date_deb = new Date(item.date_deb.valueOf()-item.date_deb.getTimezoneOffset() * 60000);
        datas.date_fin = new Date(item.date_fin.valueOf()-item.date_fin.getTimezoneOffset() * 60000);;

        
        datas.date = Math.floor(Date.now() / 1e3);
        datas.id_prof = $sessionStorage.profil.id;
        datas.id_ensemble = item.id_ensemble;
        datas.titre_ensemble = item.titre_ensemble;
        datas.type_ensemble = item.type_ensemble;
        datas.id_consigne = item.id_consigne;
        datas.podcast = Date.now() + $sessionStorage.profil.id + item.id_ensemble + item.id_consigne;
        postData.async("partage/" + id, datas).then(function(json) {
            item = json.data.datas.resultat;
            var idRef = item.type_ensemble + item.id_ensemble;
            if (!$scope.listePartages[idRef]) {
                $scope.listePartages[idRef] = {};
                $scope.listePartages[idRef].id = item.id;
                $scope.listePartages[idRef].podcast = item.podcast;
            } else {
                $scope.listePartages[idRef].id = item.id;
                $scope.listePartages[idRef].podcast = item.podcast;
            }
            $scope.saveConsigne();
        });
    };
    $scope.triggerUpload = function() {
        $timeout(function() {
            $sessionStorage.actif = $scope.activite;
            var input = document.getElementById("inputFile").click();
        }, 100);
    };


   
    $scope.uploadDoc = function(files) {
        $rootScope.loading = true;
        $scope.activite = $sessionStorage.actif;
        $scope.infoFile = "";
        var ext = files[0].name.split(".").reverse()[0];
        var fileType = files[0]["type"];
        console.info("mime",fileType);
        var filesize=files[0].size;
        if (fileType == "") {
            //fileType = "video/"+ext;
            fileType=FILE.mime(ext);
            files[0]["type"]=fileType;
            console.info("type complete",fileType);
           
        }
        
        $timeout(function() {
           console.info("wait");

        }, 1e3);
        
        
         if (!FILE.extensions()[fileType]) {
                $scope.infoUpload("interdit")
                $rootScope.loading = false;
                return false;
            } 
            else if (filesize>FILE.maxsize()) {
                $scope.infoUpload("trop_grand");
                $rootScope.loading = false;
                return false;   
            } 

            else {
                $scope.infoUpload("vide");
            }

        var fd = new FormData();
        fd.append("file", files[0]);
        var postDatas = {};
        if ($sessionStorage.profil.role == "prof") {
            postDatas.id_consigne = $scope.activite.id;
            var id_upload = "";
            if (!$scope.activite.uploads) {
                $scope.activite.uploads = [];
            }
        } else if ($sessionStorage.profil.role == "eleve") {
            postDatas.id_reponse = $scope.activite.reponse.id;
            id_upload = "";
            if (!$scope.activite.reponse.uploads) {
                $scope.activite.reponse.uploads = [];
            }
        }
        postDatas.date=Math.floor(Date.now() / 1000);
        postDatas.titre = STRING.normalise(files[0]["name"]);
        postDatas.type = files[0]["type"];
        if (files[0]["type"] == "") {
            postDatas.type = fileType;
        }
        console.info(postDatas.type);
        postDatas.login = $sessionStorage.profil.login;
        postDatas.rne = $sessionStorage.profil.rne;
        if (FILE.extensions()[fileType]) {
            if (FILEACONVERTIR[fileType]) {
                $scope.type_a_convertir = true;
            } else {
                $scope.type_a_convertir = false;
            }
            postData.async("upload/" + id_upload, postDatas).then(function(json) {
                var id_file = id_upload == "" ? json.data.datas.resultat.id : id_upload;
                $scope.uploadFile("fileUpload/" + id_file, fd);
                $rootScope.id_de_l_ajout = id_file;
            });
        } else {
            $scope.infoUpload("Fichier non autorisé.")
            $rootScope.loading = false;
        }
    };

    $scope.reloadReponses = function() {
        getData.fromUrl("consigne" + profil + "/" + $stateParams.id).then(function(json) {
            $scope.activite = json.data.datas.reponses;
            //console.info("a",$scope.activite);
            $scope.$broadcast("scroll.refreshComplete");
        });
    };

    $scope.saveMagneto = function(item) {
        var postDatas = {};
        if ($sessionStorage.profil.role == "prof") {
            postDatas.id_consigne = $scope.activite.id;
            if ($scope.activite.medias) {
                id_media = $scope.activite.medias[0].id;
            } else {
                id_media = "";
            }
        } else if ($sessionStorage.profil.role == "eleve") {
            if ($scope.activite.reponse && $scope.activite.reponse.medias) {
                var id_media = $scope.activite.reponse.medias[0].id;
            } else {
                id_media = "";
            }
            postDatas.id_reponse = $scope.activite.reponse.id;
        }
        postDatas.titre = $sessionStorage.profil.nom;
        postDatas.login = $sessionStorage.profil.login;
        postData.async("media/" + id_media, postDatas).then(function(json) {
            console.info("media", json);
            id_file = id_media == "" ? json.data.datas.resultat.id : id_media;
            postData.async("file/" + id_file, item.audioModel).then(function(json) {});
        }, function(json) {
            console.info("error");
        });
    };
    $scope.openTextarea = function() {

        $scope.modalActive = false;
        $scope.textareaConsigneItem = true;
        if ($sessionStorage.profil.role == "prof") {
            $scope.initEditor($scope.activite.text);
        }
        if ($sessionStorage.profil.role == "eleve") {

            if (!$scope.activite.reponse.text || $scope.activite.reponse.text == "") {
                var parseReponse = document.createElement("div");
                parseReponse.innerHTML = $scope.activite.text;
                
                var elementsReponse = angular.element(parseReponse).find("div.reponse");
                var html = "";
                angular.forEach(elementsReponse, function(value, key) {
                    html += value.innerHTML;
                });
                $scope.activite.reponse.text = $filter('input')(html);
                console.info( 'reponse',$scope.activite.reponse.text)
                $scope.initEditor($scope.activite.reponse.text);
            } else {
                $scope.initEditor($scope.activite.reponse.text);
            }
        }
    };

    $scope.titreAbsent = function(id) {
        var confirmPopup = $ionicPopup.confirm({
            title: "Attention !",
            template: "L'activité que vous venez de créer ne comporte pas de titre.<br> Que souhaitez-vous faire de cette activité?",
            cancelText: "Supprimer",
            okText: "Modifier"
        });
        confirmPopup.then(function(res) {
            if (res) {
                $state.go("app.consigne_edit",{id:id});
                
            }
            else{
                $scope.deleteConsigne(id);
            }
        });
    };

    $scope.openModal = function(name, type) {
        $scope.modalActive = true;
        // angular.element(".item.documents, .item.media, .item.gestion").css("display","block")
        if ($scope.textareaConsigneItem && name!=$scope.modalHelp) {
            //console.info($scope.actifUploads,$scope.actifUploads);
            $scope.color = "red";
            $scope.alertInfo = "<i class='ion-ios-information-outline'> </i>Fermez d'abord l'éditeur de la consigne (Enregistrer ou Annuler)";
            $timeout(function() {
                $scope.alertInfo = "";
            }, 2500);
            return false;
        }
        var type = type || false;
        name.show();
        if (name == $scope.modalUploads && $sessionStorage.profil.role == "eleve") {
            if (!$scope.activite.reponse.uploads) {
                $scope.saveReponse($scope.activite.reponse).then(function() {});
            }
        }
    };
    $scope.saveTextarea = function(editor, bool) {
        if (!bool) {
            $timeout(function() {
                if ($rootScope.isAndroid) {
                    cordova.plugins.Keyboard.close();
                }
                $scope.textareaConsigneItem = false;
                return false;
            }, 500);
        } else {
            var text = editor.getContent();
            console.info("TEXT", text);
            if ($sessionStorage.profil.role == "prof") {
                if ($scope.activite.id == editor.id) {
                    $scope.activite.text = text;
                    $scope.saveConsigne().then(function() {
                        $scope.textareaConsigneItem = false;
                    });
                } else {
                    if ($sessionStorage.activite.id == editor.id) {
                        $scope.activite = $sessionStorage.activite;
                        $scope.activite.text = text;
                        $scope.saveConsigne().then(function() {
                            $scope.textareaConsigneItem = false;
                        });
                    }
                }
            } else if ($sessionStorage.profil.role == "eleve") {
                if ($scope.activite.id == editor.id) {
                    $scope.activite.reponse.text = text;
                    $scope.saveReponse($scope.activite.reponse).then(function() {
                        $scope.textareaConsigneItem = false;
                    });
                } else {
                    if ($sessionStorage.activite.id == editor.id) {
                        $scope.activite = $sessionStorage.activite;
                        $scope.activite.reponse.text = text;
                        $scope.saveReponse($scope.activite.reponse).then(function() {
                            $scope.textareaConsigneItem = false;
                        });
                    }
                }
            }
        }
    };
    $scope.closeModal = function(name, type, save) {
        var type = type || false;
        var save = save || false;
        if (type && type == "inputTitre" && save) {
            $scope.saveConsigne();
            name.hide();
        }
        if (name == $scope.modalUploads) {
            $rootScope.loading = false;
        }
        if (!save) {
            name.hide();
        }
    };
    //#### Modale UPLOADS ######
    $ionicModal.fromTemplateUrl("templates/modales/uploads.html", {
        scope: $scope
    }).then(function(modal) {
        $scope.modalUploads = modal;
    });
    $ionicModal.fromTemplateUrl("info/templates/embed.html", {
        scope: $scope
    }).then(function(modal) {
        $scope.modalHelp = modal;
    });
    $ionicModal.fromTemplateUrl("templates/modales/consigneTitre.html", {
        scope: $scope,
        focusFirstInput: true
    }).then(function(modal) {
        $scope.modalTitre = modal;
    });

    $scope.openFrame=function(e){
         e.preventDefault();
         var url_or=e.currentTarget.href;
         
        var https = url_or.indexOf('https');
        console.info("index",https);

        if(https<0){
            url=url_or.replace('http://','https://');
        }
        else{
            url=url_or;
        }
        console.info(url)
       pageExist.fromUrl(url).then(function(json){
        console.info("url",json.data)
            if(json.data){
                
                $scope.frameheight=angular.element("#iframe.consigne").height();
                $scope.framewidth=angular.element("#iframe.consigne").width();
                if(!$scope.framewidth){
                    
                    $scope.frameheight=angular.element(".consigne #iframe2").height();
                    $scope.framewidth=angular.element(".consigne #iframe2").width();
                }
                console.info("WIDTH",$scope.framewidth)
                $scope.url=$sce.trustAsResourceUrl(url);
            }
            else{
                window.open(url_or,"_blank")
            }
         }
        )
        
         
          
    }

    $scope.closeFrame=function(){
        $scope.frameheight=0;
        $scope.framewidth=0;
        $scope.url=false;    
    }

    $scope.initEditor = function(text) {
        if (!text) {
            text = " ";
        }
        if (tinymce.activeEditor && tinymce.activeEditor.id!=$scope.activite.id) {
            
            $scope.tinyLoading = true;
        }
        else if (!tinymce.activeEditor) {
            $scope.tinyLoading = true;
        }
        if (!tinymce.activeEditor) {
            $scope.tinyLoading = true;
        }
        if ($scope.editor) {
            $scope.editor.setContent(text);
        }
        if ($sessionStorage.profil.role == "prof") {
            var pluginsList = "insertmenu,encadre,fullscreen,embed,link,savetext,help,lists, charmap, textcolor, codesample, code";
            var toolbar1 = " savetext annuletext encadre insertmenu help";
        } else {
            var pluginsList = "link,savetext,help,embed,lists,charmap, textcolor";
            var toolbar1 = "savetext  annuletext  help";
        }
        tinymce.init({
            language: "fr_FR",
            // change language here
            selector: "textarea.tinymce",
            plugins: pluginsList,
            menubar: false,
            height: 400,
            toolbar1: toolbar1,
            toolbar2: "bold italic underline | bullist numlist | subscript superscript | link | forecolor backcolor | charmap | removeformat  | code ",
            content_css: "css/tiny.css",
             target_list: [
                {title: 'Nouvelle page', value: '_blank'},
                {title: 'Intégration', value: '_same'}
              ],
            end_container_on_empty_block: true,
            setup: function(ed) {
                ed.on("init", function() {
                    console.info("setup")
                    $scope.editor = ed;
                    $scope.editor.id = $scope.activite.id;
                    $scope.editor.hostapp = HOSTAPP;
                    $scope.editor.setContent(text);
                    $scope.tinyLoading = false;
                     //if ($sessionStorage.profil.role == "prof") {
                    if ($sessionStorage.profil.role =="oups") {
                        if (!$scope.fullscreen) {
                            $scope.fullscreen = true;
                            $timeout(function() {
                                tinymce.activeEditor.execCommand("mceFullScreen");
                                console.info("full");
                            }, 200);
                        }
                    }
                    $timeout(function() {
                        $scope.tinyLoading = false;
                    }, 200);
                });
            },
            save: function(editor) {
                $scope.tinyLoading = false;
                //tinymce.activeEditor.getBody().setAttribute('contenteditable', false);
                $scope.saveTextarea(editor, true);
                $timeout(function() {
                    angular.element(".item.documents, .item.media, .item.gestion").css("display", "block");
                }, 500);
            },
            annuler: function(editor) {
                $scope.tinyLoading = false;
                //tinymce.activeEditor.getBody().setAttribute('contenteditable', false);
                $scope.saveTextarea(editor, false);
                $timeout(function() {
                    angular.element(".item.documents, .item.media, .item.gestion").css("display", "block");
                }, 500);
            },
            fullscreen: function() {
                if (!$scope.modalActive) {
                    angular.element(".item.documents, .item.media, .item.gestion").css("display", "none");
                    $scope.modalActive = false;
                }
            },
            fullscreenOff: function() {
                console.info("fullscreenOff");
                angular.element(".item.documents, .item.media, .item.gestion").css("display", "block");
            },
            help: function() {
                console.info("help")
                $scope.openModal ($scope.modalHelp)
            }
        });
    };
    $scope.viewResults = true;
    $scope.insert = function(chemin, type) {
        if (type == "wikimedia") {
            var re = /([1-9].px)/;
            chemin = chemin.replace(re, "300px");
        }
        chemin = "<p>" + chemin + "</p>";
        window.parent.tinyMCE.activeEditor.execCommand("mceReplaceContent", 0, chemin);
        $scope.viewResults = false;
        $scope.$broadcast("viewResults", $scope.viewResults);
        $timeout(function() {
            $scope.viewResults = true;
        }, 2e3);
    };
    $scope.tiny = function(bool) {
        $scope.tinyLoading = bool;
        if (!$scope.tinyLoading) {
            $timeout(function() {
                $scope.tinyLoading = bool;
            }, 500);
        }
    };
} ])

.config(function(recorderServiceProvider) {
    if (ionic.Platform.isIOS() || ionic.Platform.isAndroid() || ionic.Platform.isWindowsPhone()) {
        recorderServiceProvider.forceSwf(false).withMp3Conversion(false);
    } else {
        recorderServiceProvider.forceSwf(false).withMp3Conversion(true);
    }
})

.controller("ctrlReponse", [ "$scope", "$rootScope", "$stateParams", "getData", "postData", "$sessionStorage", "$localStorage", "$state", "$timeout", function($scope, $rootScope, $stateParams, getData, postData, $sessionStorage, $localStorage, $state, $timeout) {
    $rootScope.$on("$stateChangeStart", function(event, toState, toParams, fromState, fromParams) {
        if (toState.name == "app.reponse") {
            $scope.loadReponse();
        }
    });
    $scope.redonnerReponse = function(item) {
        datas = {};
        datas.publier = "N";
        datas.date = new Date();
        datas.id = item.id;
        postData.async("reponse/" + item.id, datas).then(function(json) {
            $scope.reponse.publier = "N";
            $localStorage.consigne = "reload";
            angular.forEach($sessionStorage.activite.reponses, function(reponse, key) {
                if (reponse.id == item.id) {
                    reponse.publier = "N";
                }
            });
            $rootScope.reloadActivites = true;
            $state.go("app.consigne_reponses", {
                id: $scope.reponse.id_consigne,
                publier: "N"
            });
        });
    };
    $scope.loadReponse = function() {
        getData.fromUrl("reponse/" + $stateParams.id).then(function(json) {
            $scope.reponse = json.data.datas;
            $scope.id = $scope.reponse.id;
            if ($scope.reponse.medias) {
                $scope.soundToPlay = $scope.reponse.medias[0].chemin;
            }
            $scope.reponseEleve = $scope.reponse.text;
        });
    };
    if (!$scope.reponse) {
        $scope.loadReponse();
    }
    $scope.openTextareaComment = function() {
        $scope.textareaCommentItem = true
        $scope.initEditor($scope.reponse.comment);
    };
    $scope.initEditor = function(text) {
        if (!text) {
            text = " ";
        }

         if (tinymce.activeEditor && tinymce.activeEditor.id==$scope.reponse.id_consigne) {
            tinymce.EditorManager.editors = []; 
            $scope.tinyLoading = true;
        }
        else if (!tinymce.activeEditor) {
            $scope.tinyLoading = true;
        }
        if ($scope.editor) {
            $scope.editor.setContent(text);
        }
        var pluginsList = "savetext,lists,charmap,textcolor";
        tinymce.init({
            selector: "textarea.tinymceComment",
            plugins: pluginsList,
            menubar: false,
            height: 200,
            toolbar: "bold italic underline | bullist numlist | subscript superscript | forecolor backcolor | charmap | removeformat  | savetext | annuletext ",
            content_css: "css/tiny.css",
            setup: function(ed) {
                ed.on("init", function() {
                    console.info("setup")
                    $scope.editor = ed;
                    $scope.editor.id = $scope.reponse.id;
                    $scope.editor.setContent(text);
                    $timeout(function() {
                        $scope.tinyLoading = false;
                    }, 200);
                });
            },
            save: function(editor) {
                $scope.tinyLoading = false;
                $scope.saveTextarea(editor, true);
            },
            annuler: function(editor) {
                $scope.tinyLoading = false;
                $scope.saveTextarea(editor, false);
            }
        });
    };
    $scope.saveConsigne = function() {
        var datas = {};
        datas.id = $scope.reponse.id;
        datas.comment = $scope.reponse.comment;
        return postData.async("reponse/" + datas.id, datas).then(function(json) {
            console.info("retour", json.data);
        });
    };
    $scope.saveTextarea = function(editor, bool) {
        if (!bool) {
            $timeout(function() {
                if ($rootScope.isAndroid) {
                    cordova.plugins.Keyboard.close();
                }
                // $scope.textareaDisable="true";
                $scope.textareaCommentItem = false;
                console.info("annule");
                return false;
            }, 500);
        } else {
            var text = editor.getContent();
            console.info("TEXT", text);
            if ($sessionStorage.profil.role == "prof") {
                if ($scope.reponse.id == editor.id) {
                    $scope.reponse.comment = text;
                    $scope.saveConsigne().then(function() {
                        // $scope.editor.remove();
                        $scope.textareaCommentItem = false;
                    });
                }
            }
        }
    };
} ])

.controller("ctrlOembed", [ "$scope", "$stateParams", "getData", "getDataEmbed", "$sanitize", "$sessionStorage", function($scope, $stateParams, getData, getDataEmbed, $sanitize, $sessionStorage) {
    var oembedUrls = {
        "youtu.be": "http://www.youtube.com/oembed?url=$1&format=json",
        "youtube.com": "http://www.youtube.com/oembed?url=$1&format=json",
        "dailymotion.com": "http://www.dailymotion.com/api/oembed?url=$1&maxwidth=720&format=json",
        "vimeo.com": "http://vimeo.com/api/oembed.xml?url=$1&format=json&maxwidth=300",
        "dai.ly": "http://www.dailymotion.com/api/oembed?url=$1&maxwidth=720&format=json"
    };
    var urls = /(\b(https?|ftp):\/\/[A-Z0-9+&@#\/%?=~_|!:,.;-]*[-A-Z0-9+&@#\/%=~_|])/gim;
    if (url = $scope.consigne.match(urls)) {
        console.info("url", url);
        var i = 0;
        console.info("url.length", url.length);
        bidule = $scope.consigne;
        angular.forEach(url, function(u, key) {
            parser = document.createElement("a");
            parser.href = u;
            if (provider = oembedUrls[parser.hostname]) {
                provider = provider.replace("$1", u);
                getDataEmbed.fromUrl(provider).then(function(json) {
                    bidule = bidule.replace(u, json.data.html);
                    if (url.length == i) {
                        $scope.consigne = $sce.trustAsHtml(bidule);
                    }
                });
            }
            i++;
        });
    }
} ])

.controller("ctrlPopup", [ "$scope", "$ionicPopup", "$timeout", function($scope, $ionicPopup, $timeout) {
    $scope.data = {};
    $scope.showConfirmRendre = function(item) {
        var confirmPopup = $ionicPopup.confirm({
            title: "Attention !",
            template: "Une fois rendu, vous ne pourrez plus modifier votre devoir.",
            cancelText: "Annuler",
            okText: "Rendre"
        });
        confirmPopup.then(function(res) {
            if (res) {
                console.log("Bouton RENDRE choisi");
                item.publier = "O";
                $scope.$emit("rendre", true);
                $scope.saveReponse(item);
            } else {
                console.log("Bouton ANNULER choisi");
                $scope.saveReponse(item);
            }
        });
    };
    $scope.showConfirmRedonner = function(reponse) {
        var confirmPopup = $ionicPopup.confirm({
            title: "Attention !",
            template: "Cette réponse n'apparaîtra plus dans votre liste tant que l'élève ne l'aura pas rendu de nouveau.",
            cancelText: "Annuler",
            okText: "Redonner"
        });
        confirmPopup.then(function(res) {
            if (res) {
                console.log("Bouton REDONNER choisi");
                $scope.redonnerReponse(reponse);
            } else {
                console.log("Bouton ANNULER choisi");
            }
        });
    };
    $scope.showAlert_gererclasses = function() {
        var alertPopup = $ionicPopup.alert({
            title: "Gestion des classes",
            template: "Cocher vos classes dans la liste."
        });
    };
    $scope.showAlert_gerergroupes = function() {
        var alertPopup = $ionicPopup.alert({
            title: "Gestion des groupes",
            template: "Cocher vos groupes dans la liste."
        });
    };
} ])

.controller("ctrlUploadsView", [ "$scope", "$rootScope", "$ionicModal", "$window", "$sce", "$timeout", "HOST", function($scope, $rootScope, $ionicModal, $window, $sce, $timeout, HOST) {
    $scope.openModalImage = function(chemin) {
        $scope.image = $rootScope.host + chemin;
        $scope.focus = "<img src='" + $rootScope.host + chemin + "'>";
    };
    $scope.openModalVideo = function(chemin) {
        $scope.video = $rootScope.host + chemin;
        $scope.focus = $sce.trustAsHtml("<video  controls src='" + $scope.video + "'></video>");
        $timeout(function() {
            document.getElementsByTagName("video")[0].play();
            console.log("lance video");
        }, 3e3);
    };
    $scope.fermeFocus = function() {
        $scope.focus = "";
    };
    $scope.openDocNewBlank = function(upload) {
        var chemin = upload["chemin"];
        var titre = upload["titre"];
        var url = HOST + chemin;
        var link = document.createElement("a");
        link.href = url;
        link.target = "_blank";
        link.click();
    };
    $scope.openDocIFrame = function(upload) {
        if (upload.type == "application/pdf") {
            console.info("doc", upload.type);
            var chemin = upload["chemin"];
            var titre = upload["titre"];
            var url = HOST + chemin;
            $scope.urldelaiframe = url;
            $scope.iframevisible = true;
        } else {
            $scope.openDocDownload(upload);
        }
    };
    $scope.frameVisible = function() {
        $scope.iframevisible = !$scope.iframevisible;
    };
    $scope.openDocDownload = function(upload) {
        console.info("download");
        var chemin = upload["chemin"];
        var titre = upload["titre"];
        var url = HOST + chemin;
        var link = document.createElement("a");
        link.download = titre;
        link.href = url;
        link.click();
    };

   
    $scope.bigModalImage = function(chemin) {
        $scope.modalClass = "modalBig";
    };
    $scope.smallModalImage = function(chemin) {
        $scope.modalClass = "";
    };

    $scope.partage=function(upload){
        console.info("upload",upload);
        if(!upload.width){
            upload.width=300;
            upload.height=200;
        }
        if($scope.visible && $scope.visible[upload.id]){
            $scope.visible[upload.id]=false
        }
        else{
            $scope.visible=[]
            var width=upload.width;
          $scope.visible[upload.id]=true 
           $scope.width=upload.width;
           $scope.height=upload.height*width/width;
            
       }
    }

     $scope.calculeheight=function(width,upload){
        
         $scope.width=upload.width;
           $scope.height=upload.height*width/width;
           console.info("change",$scope.height)
    }

    $rootScope.$on('$stateChangeStart', 
        function(event, toState, toParams, fromState, fromParams){
            $scope.fermeFocus();
        }
    )

    
} ])
