angular.module('groupeController', ['baladoServices', 'ngStorage'])

///////////////////////////////////////////////////
///////////////////////////////////////////////////
// RECUPERATION DES GROUPES DE L'ETABLISSEMENT
///////////////////////////////////////////////////
///////////////////////////////////////////////////
.controller('ctrlListeGroupes', function($rootScope, $ionicModal,$scope, getData, deleteData,$location, $sessionStorage,$localStorage, $state, $ionicHistory, postData) {
    $rootScope.$on('$stateChangeStart',function(event, toState, toParams, fromState, fromParams){ 
            if(fromState.name=="app.gerergroupeedition"){
                $scope.loadGroupes();
            }

        })


    
    $scope.loadGroupes=function(){
        var groupesduprof=[];
        getData.fromUrl("groupes/id_prof/"+ $sessionStorage.profil.id).then(function(json) { 
            if(json.data.datas.length<1){
                $scope.groupesduprof={};
            }
            else{
                 $scope.groupesduprof=json.data.datas;
            }
           
            console.info("$scope.groupesduprof",$scope.groupesduprof)
            // On cherche l'effectif de chaque groupe
            for(gpe in $scope.groupesduprof)
            {   
                getData.fromUrl("groupe/"+gpe).then(function(json) 
                { 
                    $scope.groupesduprof[gpe].effectif=json.data.datas.effectif;
                });
            }
        });
    }

   
    $scope.nouveauGroupe=function(){
        var datas={};
        var i=1;
        var max=1;

        // On vérifie que le libellé du groupe n'existe pas déjà
        getData.fromUrl("groupes/id_prof/"+$sessionStorage.profil.id).then(function(json) 
        {   $scope.groupes=json.data.datas;

            for(i=1;i<=max;i++)
            {
            for(gpe in $scope.groupes)
                {   //console.info("$scope.groupesduprof[gpe].libelle",$scope.groupesduprof[gpe].libelle);
                    //console.info("i",i);
                    if($scope.groupesduprof[gpe].libelle=="votre_nouveau_groupe_"+i)
                        {   //console.info("Je rentre dans la boucle");
                            //i++;}
                            max++;
                            break;
                        }
                }
            }
        // On nomme le nouveau groupe "votre_nouveau_groupe_" suivi du compteur
        datas.libelle="votre_nouveau_groupe_"+max;
        datas.rne=$sessionStorage.profil.rne;
        console.info("$scope.groupesduprof",$scope.groupesduprof)
        postData.async("groupes/",datas).then(function(json){
                newGroupe=json.data.datas.resultat;
                $scope.groupesduprof[newGroupe.id]=newGroupe;
               
                $localStorage.consigne='reload';
                 console.info( '%c consigne :'+ $localStorage.consigne , ' color: #bada55');

        });
        })
    } 


    if($sessionStorage.profil.role=="prof"){

       $scope.loadGroupes();
        
    }
})


.controller('ctrlListeEleves',function($rootScope, $ionicPopup,$ionicModal,$scope, getData, deleteData,$location, $sessionStorage,$localStorage, $state, $stateParams, $ionicHistory, postData,$localStorage){

    if($sessionStorage.profil.role=="prof")
    {
        // On liste les groupes du prof
        var groupesduprof=[];
        getData.fromUrl("groupes/id_prof/"+ $sessionStorage.profil.id).then(function(json) 
        { 
            $scope.groupesduprof=json.data.datas;
        });


        // Recherche des infos sur le groupe en cours
        getData.fromUrl("prof/"+$sessionStorage.profil.id).then(function(json) 
        {
            $scope.groupes=json.data.datas.groupes;
            for(gpe in $scope.groupes)
            {   
                if($scope.groupes[gpe].id==$stateParams.id)
                {   
                    $scope.groupeencours=$scope.groupes[gpe];
                }
            }
        });

        var ClassesProf=$sessionStorage.profil.classes;
        // Recherche de tous les élèves de l'établissement
        
        getData.fromUrl("elevesclasse/rne/"+ $sessionStorage.profil.rne).then(function(json) 
        { 
            var classesEtablissement={};
            $scope.classesEtablissement=json.data.datas;
            for(classs in $scope.classesEtablissement)
             {   
                $scope.classesEtablissement[classs].deplier=true;
            //    for (classss in ClassesProf)
            //     {   
            //         if(classs==ClassesProf[classss].id)
            //         {
            //             $scope.classesEtablissement[classs].libelle=ClassesProf[classss].classe;
            //         }
            //     }
                for(elev in $scope.classesEtablissement[classs])
                {                 
                    $scope.classesEtablissement[classs][elev].checked=false;
                    //console.info("$scope.classesEtablissement[classs].length",$scope.classesEtablissement[classs].length);
                }
            }
        }).then(function(){



        ///////////////////////////////////////////////////////////////////
        // ON RECUPERE LE NOM (LIBELLE) DE CHAQUE CLASSE DE L'ETABLISSEMENT
        ///////////////////////////////////////////////////////////////////
        getData.fromUrl("classe/").then(function(json)
        {
            var touteslesclasses={};
            $scope.touteslesclasses=json.data.datas;
            for(uneclasse in $scope.touteslesclasses)
            {
                for(classedeletab in $scope.classesEtablissement)
                {
                    if($scope.touteslesclasses[uneclasse].id==classedeletab)
                    {
                        $scope.classesEtablissement[classedeletab].libelle=$scope.touteslesclasses[uneclasse].classe;
                        $scope.classesEtablissement[classedeletab].id=$scope.touteslesclasses[uneclasse].id;
                    }
                }
            }
        })
    }).then(function(){


        // Recherche des élèves du groupe 
        var elevesdugroupe=[];
        getData.fromUrl("groupe/"+$stateParams.id).then(function(json) 
        { 
            if(json.data.datas.eleves)
            {$scope.elevesdugroupe=json.data.datas.eleves;}
            $scope.effectifgroupe=json.data.datas.eleves.length;
            for(elev in $scope.elevesdugroupe)
            {
                for(classs in $scope.classesEtablissement)
                {   
                    for(elevv in $scope.classesEtablissement[classs])
                    {
                        if($scope.classesEtablissement[classs][elevv].id==$scope.elevesdugroupe[elev].id)
                        {
                            $scope.classesEtablissement[classs][elevv].checked=true;
                        }
                    }
                 }
                $scope.elevesdugroupe[elev].checked=true;
            }
        });
        })
        
        $scope.elevesProf={};
        
        getData.fromUrl("elevesclasse/rne/"+ $sessionStorage.profil.rne).then(function(json) 
        { 
            var classesEtablissement=json.data.datas;
            angular.forEach(ClassesProf, function(classe, key) 
            {
                if(!$scope.elevesProf[classe.classe])
                {
                    $scope.elevesProf[classe.classe]={};
                }
                $scope.elevesProf[classe.classe].classe=classe;
                $scope.elevesProf[classe.classe].eleves=$scope.classesEtablissement[classe.id];
                for(eleve in $scope.elevesProf)
                {
                    if(!$scope.elevesProf[classe.classe])
                    {
                        $scope.elevesProf[classe.classe]={};
                    }
                    $scope.elevesProf[classe.classe].classe=classe;
                    $scope.elevesProf[classe.classe].eleves=$scope.classesEtablissement[classe.id];
                }
            });
        })


$ionicModal.fromTemplateUrl('templates/modales/modalGroupetitre.html', {
    scope: $scope,
    focusFirstInput:true
  }).then(function(modal) {
    $scope.modalGroupetitre = modal;
    
   
  });

$ionicModal.fromTemplateUrl('templates/modales/modalGroupeliste.html', {
    scope: $scope,
  }).then(function(modal) {
    $scope.modalGroupeliste = modal;
    
  });

$scope.openModalGroupetitre = function() {
    $scope.modalGroupetitre.show();

    $scope.modalGroupetitre.text=$scope.groupeencours.libelle;
  };

$scope.openModalGroupeliste = function() {
    getData.fromUrl("groupe/"+$stateParams.id).then(function(json) { 
        $scope.modalGroupeliste.text=json.data.datas.eleves;
    }).then(function(){
        $scope.modalGroupeliste.text.forEach(function (eleve, key){
            for(classe in $scope.touteslesclasses){
                if (eleve.id_classe == $scope.touteslesclasses[classe].id){
                    eleve.classe = $scope.touteslesclasses[classe].classe
                }
            }
        })
        $scope.modalGroupeliste.show();
    })
    
  };

$scope.closeModalGroupetitre = function() {
var datas={};
datas.id=$stateParams.id;
datas.id_prof=$sessionStorage.profil.id;
 datas.libelle=$scope.modalGroupetitre.text;
 console.info("datas",datas)
    postData.async("groupes/"+$stateParams.id,datas).then(function(json) { 
          console.info("retour POST",json); 
         $scope.groupeencours.libelle=$scope.modalGroupetitre.text;
         $localStorage.consigne='reload';
          console.info( '%c consigne :'+ $localStorage.consigne , ' color: #bada55');
          //$state.go("app.tabconsigne", {id:$scope.reponse.id_consigne}, { reload: true });
        }) 
    $scope.modalGroupetitre.hide();
    if(!$rootScope.isWebView){
      StatusBar.hide();
    }
   
  };

  $scope.closeModalGroupeliste = function() {
    $scope.modalGroupeliste.hide();
    if(!$rootScope.isWebView){
      StatusBar.hide();
    }
   
  };
}

$scope.showConfirmsuppr = function() {
   var confirmPopup = $ionicPopup.confirm({
     title: 'Suppression de groupe',
     template: 'Etes-vous sûr(e) de vouloir supprimer ce groupe définitivement ?',
     okText:'Oui',
     cancelText:'Non'
   });

   confirmPopup.then(function(res) {
     if(res) {
       console.log('You are sure');
       var datas={};
       var compteur=0;
        datas.id_groupe=$stateParams.id;
        // On récupère tous les partages du prof   
            getData.fromUrl("partages/id_prof/"+$sessionStorage.profil.id).then(function(json) {
                for(partage in json.data.datas)
                    {   //console.info("partage",partage);
                        //console.info("json.data.datas[partage].type_ensemble",json.data.datas[partage].type_ensemble);
                        // On ne garde que les groupes
                        if(json.data.datas[partage].type_ensemble=="groupe")
                        {   //console.info("json.data.datas[partage].id_ensemble",json.data.datas[partage].id_ensemble);
                            //console.info("$stateParams.id",$stateParams.id);
                            // On compte le nb de partages en cours avec ce groupe
                            if(json.data.datas[partage].id_ensemble==$stateParams.id)
                            {
                                compteur++;
                            }
                        }
                    }
            // S'il y a 1 partage, pas de suppression, message d'erreur
              if(compteur==1){
                 $scope.info="--> Il faut d'abord supprimer le partage en cours avec ce groupe."                
              }
              // S'il y a plusieurs partages, pas de suppression, message d'erreur
              else if(compteur>1){
                $scope.info="--> Il faut d'abord supprimer les "+compteur+" partages en cours avec ce groupe."                  
              }
              // S'il n'y a pas de partages, on supprime
              else{
                    deleteData.fromUrl("groupes/"+datas.id_groupe).then(function(json){   

                            delete($scope.groupesduprof[datas.id_groupe]);
                            $sessionStorage.profil.groupes=$scope.groupesduprof;
                            $state.go('app.gerergroupe',{'reload':"groupes"});
                            $localStorage.consigne='reload'
                             console.info( '%c consigne :'+ $localStorage.consigne , ' color: #bada55');
                            
                        });                 
              }
              
            })
          
        }
 else {
       console.log('You are not sure');
     }
   });
 };

 $scope.cocherClasse=function(item){
    var datas=item;
    if(item.length!=0)
        {
            var id_de_la_classe=item[0].id_classe;
        }
    for(eleve in item)
       {  
        if($scope.classesEtablissement[id_de_la_classe][eleve].checked==false)
            {
                item[eleve].checked=false;
                $scope.saveGroupe(item[eleve]);
                $scope.classesEtablissement[id_de_la_classe][eleve].checked=true;
            }
        }
   }

$scope.decocherClasse=function(item){
    var datas=item;
    if(item.length!=0)
        {
            var id_de_la_classe=item[0].id_classe;
        }
    for(eleve in item)
       {  
        if($scope.classesEtablissement[id_de_la_classe][eleve].checked==true)
            {
                item[eleve].checked=true;
                $scope.saveGroupe(item[eleve]);
                $scope.classesEtablissement[id_de_la_classe][eleve].checked=false;
            }
        }
    return item;
   }

$scope.deplierClasse=function(item){
    var datas=item;
    if(item.length!=0)
        {
            var id_de_la_classe=item[0].id_classe;
        }
    if($scope.classesEtablissement[id_de_la_classe].deplier==true)
    {
        $scope.classesEtablissement[id_de_la_classe].deplier=false;
    }
    else if($scope.classesEtablissement[id_de_la_classe].deplier==false)
    {
        $scope.classesEtablissement[id_de_la_classe].deplier=true;
    }
    return item;
   }

$scope.saveGroupe=function(item){
        var datas={};
        datas.id_groupe=$stateParams.id;
        datas.id_eleve=item.id;
        //console.info("L'item est",item);
        // Si l'élève était checked,...
        //console.info("L'eleve",item.nom," est checked ? ",item.checked);
        if(item.checked==true)
        {
            datas.nature="delete";  
            $scope.effectifgroupe--;
            postData.async("eleve_groupe/"+datas.id_groupe,datas).then(function(json) 
            {
                console.info("retour POST",json);
            });
            item.checked=false;
            //console.info("L'eleve",item.nom," sera checked ? ",item.checked);
        }
        // Si l'élève n'était pas checked,...    
        else
        {   
            datas.nature="ajout";
            item.checked=false;
            $scope.effectifgroupe++;
            postData.async("eleve_groupe/"+datas.id_groupe,datas).then(function(json) 
            {
                console.info("retour POST",json);
            });
            item.checked=true;
            //console.info("L'eleve",item.nom," sera checked ? ",item.checked);
        }
    return item; 
  }






  

})