//"use strict";
angular.module('baladoServices', ['ngRoute','constantes','ngStorage'])

.factory('STRING',function($http,HOST,$sessionStorage){
  return {
    normalise: function(string) { 
      var newString=string.replace(/ /g,"").toLowerCase();
      return newString.replace(/[^\w\s\.]/gi, '')     
   },
  }
})

.factory('FILE', function($sessionStorage,getconfig) {
  if(!$sessionStorage.conf && $sessionStorage.profil && $sessionStorage.profil.id){
    getconfig.dist();
  }

  return {
    maxsize: function() {
      if($sessionStorage.conf){
        return  $sessionStorage.conf.filemaxsize;
      }
      else return 0;
    },
    extensions: function() {
      if($sessionStorage.conf){
        return  $sessionStorage.conf.extensions;

      }
      else return 0;
    },

    mime: function(extension) {
      var videos=['flv','mp4','3gp','mkv','mov','mkv','avi','wmv'];
      var audios=['mp3','m4a','wav','ogg','aac'];
      var images=['jpg','jpeg','gif','png'];
      var applications=['txt','doc','docx','pdf','odt','ods','xls','xlsx','ppt','pptx','sb2'];
      if(videos.indexOf(extension) >= 0){
         return "video/"+extension 
      }
      else if(audios.indexOf(extension) >= 0) {
        return "audio/"+extension 
      }
      else if(images.indexOf(extension) >= 0){
        return "image/"+extension 
      }
      else if(applications.indexOf(extension) >= 0){
        return "application/"+extension 
      }

      else return false;
    },

    // mime: function(extension) {
    //   if($sessionStorage.conf){
    //     var extensions=$sessionStorage.conf.extensions;
    //     angular.forEach(extensions,function(val,key){
    //       if(val.e==extension){
    //         console.info("service",key);
    //         return key;
    //       }
    //     })
    //     return false
    //   }
    //   else return false;
    // },

    listextensions: function() {
      if($sessionStorage.conf){
        var extensions=$sessionStorage.conf.extensions;
        var liste={};
        
        angular.forEach(extensions,function(val,key){
          if(!liste[val.t]){
            liste[val.t]={};
          }
           if(key!='application/ogg'){
            liste[val.t][val.e]={}
          
            liste[val.t][val.e].e=val.e
           }
          
          
        })
        console.info(liste)
        return  liste;

      }
      else return 0;
    }
  }

})


.factory('getconfig', function($http,HOST,$sessionStorage) {
console.info('getconfig');
delete($sessionStorage.conf);
  return {
    dist: function() {
     $http.get(HOST+'filesallowed',{"headers":{ "Authorization": "Bearer "+$sessionStorage.jwt}}).then(function(json){
        var extensions=json.data.datas.extensions
        angular.forEach(extensions,function(val,key){
         var extension={}
          switch(key.split("/")[0]) {
            case "application":
                extension.t="document";
                break;
            case "video":
                if(key=="video/webm"){
                  extension.t="application"
                }
                 else extension.t="video"
                break;
            case "image":
                 extension.t="image"
                break;
            case "audio":
                 extension.t="audio"
                break;
            default:
                extension.t="document"
          }
          extension.e=val;
          extensions[key]=extension;
        })
        if(!$sessionStorage.conf)$sessionStorage.conf={};
        $sessionStorage.conf.extensions=extensions;
        $sessionStorage.conf.filemaxsize=json.data.datas.filemaxsize;
     });
    }
  }

})

.service('pageExist', function($http,HOST) {

  return {

    fromUrl: function(url) {
      return $http.get(HOST+"header.php?url="+encodeURI(url));  //1. this returns promise

    }
  };

})

.service('deleteData', function($http,HOST,$sessionStorage) {

  return {

    fromUrl: function(rest) {
       
      return $http.delete(HOST+rest,{"headers":{ "Authorization": "Bearer "+$sessionStorage.jwt}});  //1. this returns promise

    }
  };
})

.service('getData', function($http,HOST,$sessionStorage) {

  return {
    fromUrl: function(rest) {
     
      return $http.get(HOST+rest,{"headers":{ "Authorization": "Bearer "+$sessionStorage.jwt}});  //1. this returns promise

    }
  };
})
.service('getDataEmbed', function($http,HOST,$sessionStorage) {

  return {
    fromUrl: function(rest) {
    
      //return $http.get(rest); 
      return '<iframe src="https://www.youtube.com/embed/'+rest+'&amp;rel=0&amp;controls=&amp;autoplay=1&amp;showinfo=0" frameborder="0" allowfullscreen></iframe>';
       
    }
  };
})

.service('getBlob', function($http,HOST,$sessionStorage) {

  return {
    fromUrl: function(rest) {
       delete $http.defaults.headers.common['X-Requested-With']; 
      return $http.get(HOST+rest,{responseType: "blob","headers":{ "Authorization": "Bearer "+$sessionStorage.jwt}});  //1. this returns promise
    }
  };
})

.service('postData', function($http,HOST,$sessionStorage) {
  return {
    async: function(rest,data) {
    	 
      return $http.post(HOST+rest,data,{"headers":{ "Authorization": "Bearer "+$sessionStorage.jwt}});  //1. this returns promise
    }
  };
})

.service('uploadData', function($http,HOST,$sessionStorage) {
 return {
    async: function(rest,fd) { 
     
return $http.post(HOST+rest, fd, {
        withCredentials: true,
        headers: {'Content-Type': undefined ,"Authorization": "Bearer "+$sessionStorage.jwt},
        transformRequest: angular.identity
    });
  }
}
})




.service('rest', function($http){
	return {
		getData: function(url) {
			return $http.get(url);
		},
		postData: function(url,data) {
			return $http.get(url,data);
		}
	};
})

.service('JWT', function(  ){
    
    return{

      /* Initialiation */
      init : function(){
          this.iat = null; /* connexion */
          this.nbf = null; /* accès */  
          this.exp = null; /* expiration */
          this.ens = null;
          this.ien = null;
          this.adm = null;
          /*
          this.iatString = '';
          this.nbfString = '';
          this.expString = '';
          */
          this.token = null;
          this.tokenDecode = null;
          /* heure courante */
          this.date = new Date();
          this.heureCourante = toolsService.dateObjToString( this.date);
          /* session en cours */
          if( $sessionStorage.jwt ){
            this.setJWT( $sessionStorage.jwt ).exportValues().dbug();
          }

          return this;
      },


      isExpire : function(){
          return null === this.token;
      },

      
      

      /* Expiration */
      logout  : function(){
          delete $sessionStorage.jwt;
          this.init();
          $rootScope.delai  = null;
          $location.path('/logout');
          return this;
      },

      /* Clean */
      clean : function(){
        $rootScope.message = '';
        $rootScope.niveau = 'info';
        return this;
      },

      /**
      * Decodage du JWT
      * @param jwt
      * @returns {*}
      */
      decodeToken : function( jwt ){
          var a = jwt.split(".");
          return  b64utos(a[1]); /* jsrsasign */
      },

      /**
      * Initialisation du JWT
      * @param data
      */
      setJWT  : function(data){ 
          this.token = data;
          this.claim = this.decodeToken(data);
          return this;
      },

      setExpire : function(expire){
        this.exp =new Date(expire * 1000);
        this.expString = toolsService.dateObjToString(this.exp);
      },

      /**
      * Affecte les valeurs courantes du JWT aux containeurs respectifs.
      */
      exportValues : function(){
        
          var parsedJSON = JSON.parse(this.claim);
 
          if (parsedJSON) {

            this.iss = parsedJSON.iss;
            this.data = parsedJSON.data;

            this.iat = new Date(parsedJSON.iat * 1000);
            this.nbf = new Date(parsedJSON.nbf * 1000);
            this.exp = new Date(parsedJSON.exp * 1000);

            this.iatString = toolsService.dateObjToString(this.iat);
            this.nbfString = toolsService.dateObjToString(this.nbf);
            this.expString = toolsService.dateObjToString(this.exp);

            this.ens = ( 'ens' == this.profil().role );
            this.ien = ( 'ien' == this.profil().role );
            this.adm = ( 'adm' == this.profil().role );
          }

          var beautifiedJSON = JSON.stringify( parsedJSON, null, 4);
          this.tokenDecode = (this.claim) ? beautifiedJSON : '';

          return this
      },

      profil : function(){
        if( this.data ){
          return this.data.profil;
        } else {
          return false;
        }
      },

}})
