  tinymce.PluginManager.add('pagebreak2', function(editor) {
    // Add a button that opens a window
    tclassesPageBreakAfter=[ {'text':'Non','value':{'type':'page-break-after','value':false}},
                            {'text':'avoid','value':{'type':'page-break-after','value':'avoid'}},
                            {'text':'always','value':{'type':'page-break-after','value':'always'}},
                             {'text':'left','value':{'type':'page-break-after','value':'left'}},
                              {'text':'right','value':{'type':'page-break-after','value':'right'}},
                            ]
    tclassesPageBreakBefore=[{'text':'Non','value':{'type':'page-break-before','value':false}},
                            {'text':'avoid','value':{'type':'page-break-before','value':'avoid'}},
                            {'text':'always','value':{'type':'page-break-before','value':'always'}},
                            {'text':'left','value':{'type':'page-break-before','value':'left'}},
                            {'text':'right','value':{'type':'page-break-before','value':'right'}}
                            ]
     tclassesPageBreakInside=[{'text':'Non','value':{'type':'page-break-inside','value':false}},
                            {'text':'avoid','value':{'type':'page-break-inside','value':'avoid'}},
                            {'text':'auto','value':{'type':'page-break-inside','value':'auto'}}
                            ]

    editor.addButton('pagebreak2', {
        text: 'PageBreak',
        icon: false,
        onclick: function() {
            // Open window
            actif=editor.selection.getNode();
             var attafter=angular.element(actif).attr('page-break-after')
             var attbefore=angular.element(actif).attr('page-break-before')
             var attinside=angular.element(actif).attr('page-break-inside')
            console.info("attbefore",attbefore)
            tinymce.each(tclassesPageBreakAfter, function(item, i) { 
                if(item.value.value==attafter){
                    item.selected="selected"; 
                } 
                else{
                    delete item.selected
                } 
            });
             tinymce.each(tclassesPageBreakBefore, function(item, i) { 
                if(item.value.value==attbefore){
                    item.selected="selected"; 
                } 
                else{
                    delete item.selected
                } 
            });
            tinymce.each(tclassesPageBreakInside, function(item, i) { 
                if(item.value.value==attinside){
                    item.selected="selected"; 
                } 
                else{
                    delete item.selected
                } 
            });


           
            
            editor.windowManager.open({
                title: 'PageBreak',
                body: [
                    
                    {   type: 'listbox', 
                        name: 'pagebreakafter', 
                        label: 'PageBreakAfter', 
                        'values':  tclassesPageBreakAfter,


                    },
                     {   type: 'listbox', 
                        name: 'pagebreakbefore', 
                        label: 'PageBreakBefore', 
                        'values':  tclassesPageBreakBefore,

                    },
                    {   type: 'listbox', 
                        name: 'pagebreakinside', 
                        label: 'PageBreakInside', 
                        'values':  tclassesPageBreakInside,
                        
                    }
                ],
               
                onsubmit: function(e) {
                    console.info("e.data",e.data)
                    // Insert content when the window form is submitted
                    if(!e.data.pagebreakafter.value){
                        angular.element(actif).removeAttr('page-break-after')    
                    }
                    else{      
                        angular.element(actif).attr('page-break-after',e.data.pagebreakafter.value)         
                    }
                    if(!e.data.pagebreakbefore.value){
                        angular.element(actif).removeAttr('page-break-before')    
                    }
                    else{
                        angular.element(actif).attr('page-break-before',e.data.pagebreakbefore.value)     
                    }
                    if(!e.data.pagebreakinside.value){
                        angular.element(actif).removeAttr('page-break-inside')    
                    }
                    else{
                        angular.element(actif).attr('page-break-inside',e.data.pagebreakinside.value)     
                    }
                    var txt=tinyMCE.activeEditor.getContent()
                    tinyMCE.activeEditor.setContent(txt);
                    
                }
            });
        }
    });

    // Adds a menu item to the tools menu
    // editor.addMenuItem('example', {
    //     text: 'Example plugin',
    //     context: 'tools',
    //     onclick: function() {
    //         // Open window with a specific url
    //         editor.windowManager.open({
    //             title: 'TinyMCE site',
    //             url: 'http://www.tinymce.com',
    //             width: 800,
    //             height: 600,
    //             buttons: [{
    //                 text: 'Close',
    //                 onclick: 'close'
    //             }]
    //         });
    //     }
    // });
});