<?php
class Dupliquer extends Modele { 
	
	public $id;
	public $params;
	public $profil;
	public $id_tag;
	public $id_consigne;


	public function __construct($id=0,$key=NULL,$rest='GET',$profil=NULL){ 
		
		parent::__construct('consignes',$id,$key=NULL,$rest);
		
		$this->profil=$profil;
		$this->datas=array();

		
	// en GET on renvoie les données de l'activité demandée (comme dans Consignes/get)
		if($this->getRest()=="GET"){  

			$this->datas=$this->selectById();

				$uploads=new Modele("profs_uploads",$this->getId(),"id_consigne");
				foreach ($uploads->select() as $upload){
					$unupload=new Upload($upload['id'],"id","GET",$profil,"profs_uploads");
					$this->datas['uploads'][]=$unupload->datas;
				}

				$medias=new Modele("profs_media",$this->getId(),"id_consigne");
				foreach ($medias->select() as $media){
					$unmedia=new Media($media['id'],null,"GET",$profil,"profs_media");
					$this->datas['medias'][]=$unmedia->datas;
				}
				// correction Envole
				// $tags=new Tags_Consigne($this->getId(),null,"GET",null);
				// $this->datas['tags']=$tags->datas;

		}
		
	// en POST on va écrire le PostData dans une nouvelle consigne pour le prof qui fait la duplication
		elseif($this->getRest()=="POST"){  

			$this->postData=json_decode(file_get_contents("php://input"));

		/* obtention du login du prof qui duplique (pour la construction des noms de fichiers) */
		/* soit dans un champ login du Postdata, soit dans le profil (construit avec auth.php) */
			if (!isset($this->postData->login)) {
				$this->postData->login=$profil->login;
			}

		/* vérifications et reconstruction d'une nouvelle ligne de consignes */
			$this->newDatas = (object) array();
			$this->newDatas->id_prof 	= $profil->id;
			$this->newDatas->text 		= utf8_decode($this->postData->text);
			$this->newDatas->titre		= utf8_decode($this->postData->titre);
			$this->newDatas->public 	= 0; //non publique par défaut
			$this->newDatas->archive 	= 0; //non publique par défaut
			$this->newDatas->motscles	= utf8_decode($this->postData->motscles);
			unset($this->newDatas->date);
			
			$result=$this->save($this->newDatas); // $result['id'] est l'identifiant de la nouvelle consigne créée
			$this->datas['resultat']=$result;
			$id_consigne=$result['id'];
 
		/* duplication des tags vers le nouveau numéro de consigne */
			$tags=new Tags_Consigne($id_consigne,null,"POST",null);
			foreach ($this->postData->tags as $tag) {
				$tags->ajouteTag($tag->id_tag);
			}

		/* uploads */
			$uploads=new Modele("profs_uploads",$id_consigne,"id_consigne");
			foreach ($this->postData->uploads as $upload){
				$unupload=new Upload(null,"id","GET",$profil,"profs_uploads");

				$upload->id_consigne=$id_consigne;
				$upload->id_prof=$profil->id;
				unset($upload->id);		//autocréé lors du save()
				unset($upload->date); 	//aussi
				$chemin_source = $upload->chemin;
				$upload->chemin="voice/profs/".$this->postData->login."/".$id_consigne."/".$upload->titre;

				File::cheminMedia((array)$upload);
				if(copy($chemin_source,$upload->chemin)){
					$resultat= $unupload->save($upload);
				}
				else { echo('ERREUR de copie du fichier '.$upload->chemin);}
			}

		/* medias */
			$medias=new Modele("profs_media",$id_consigne,"id_consigne");
			foreach ($this->postData->medias as $media){
				$unmedia=new Media(null,"id","GET",$profil,"profs_media");

				$media->id_consigne=$id_consigne;
				$media->id_prof=$profil->id;
				unset($media->id);		//autocréé lors du save()
				unset($media->date); 	//aussi
				$chemin_source = $media->chemin;
				$media->chemin="voice/profs/".$this->postData->login."/".$id_consigne."/".$media->titre.".mp3";
				/* TODO : reformater le nom du fichier en NOM_id.mp3 car il reste un fichier orphelin sur le serveur en cas de réenregistrement */
				File::cheminMedia((array)$media);
				if(copy($chemin_source,$media->chemin)){
					$resultat= $unmedia->save($media);
				}
				else { echo('ERREUR de copie fichier '.$media->chemin);}
			}
	
		} //fin de la section POST
	}

	
}
?>