<?php

class Eleve extends Modele { 
	
	public $id;
	public $profil;
	

	public function Eleve($id,$key=null,$rest="GET",$profil=null){ 
		
		parent::__construct('eleves',$id,null,$rest);
		
		
		$this->datas=array();
		$this->profil=$profil;

		if(isset($this->profil->action)) { if ($this->profil->action=="audit") { 
			$this->auditTable('eleves','rne','etablissements','RNE');
			$this->auditTable('eleves','id_classe','classes','id'); //est-ce qu'on garde les élèves sans classe ?
		}}
		else
		{ 

		$this->role="eleve";
		$this->datas['role']=$this->role;
		
		$this->datas=$this->selectById();

		if($this->getRest()=="GET" || $this->getRest()=="POST"){

			if(isset($this->datas['id_classe'])) {
				$classe=new Classe($this->datas['id_classe']);
				$this->datas['classe']=$classe->datas;
			}

			//if(isset($this->datas['id_groupe'])) {
				 $groupe=new Modele("eleves_groupes",$id,"id_eleve");
				 $groupes=$groupe->select();
				 foreach( $groupes as $g){
				 	$id_groupe=$g['id_groupe'];
				 	$gi=new Modele("profs_groupes",$id_groupe);
				 	$this->datas['groupe'][$id_groupe]=$gi->selectById();
				 }
			//}

			$etablissement=new Etablissement($this->datas['rne'],'rne');
			$this->datas['etablissement']=$etablissement->datas;

		}
		elseif($this->getRest()=="DELETE"){
			$force = "";
			if(isset($this->profil->action)) { if ($this->profil->action=="terminator") { $force = "force_delete"; }}

			$this->deleteEleve($force);
		}

		}
	}


	public function deleteEleve($force=""){

		// On efface en cascade les éléments qui référencent cet Elève (where id_eleve) :
		//  eleves_groupes
		//  réponses

		// eleves_groupes
		$nbr_elvgrp=0; $del_elvgrp=0;
		$eleves_groupes=new Modele("eleves_groupes",$this->getId(),"id_eleve");

		$params['champs']="id_eleve";
		$eleves_grp= $eleves_groupes->select($params);
		$nbr_elvgrp=count($eleves_grp);
		$del_elvgrp+=$eleves_groupes->delete("id_eleve"); // TODO il faudait plutot par id avec une clé unique

		// réponses
		$nbr_rep=0; $del_rep=0;
		$reponses=new Modele("reponses",$this->getId(),"id_eleve");
		foreach ($reponses->select() as $reponse){
			$nbr_rep++;
			$unereponse=new Reponse($reponse['id'],"id",null,$this->role);
			$del_rep+=$unereponse->deleteReponse($force);
		}

		$nbr = 0;
		if (($nbr_elvgrp==$del_elvgrp && $nbr_rep==$del_rep) || $force=="force_delete") { 
			// on efface l'enregistrement Elève
			$nbr = $this->delete(); 
			$this->datas['resultat']=$nbr." élève(s) effacé(s), dont :";
			if ($nbr==1) { $this->datas['resultat']="Elève ".$this->getId()." bien effacé, dont : ";} 
			else { $this->datas['resultat']="Elève ".$this->getId()." NON effacé (problème inconnu), dont : ";}

		} else { 
			// si problème avec l'effacement des éléments enfants on n'efface pas la réponse, à moins d'etre en "forcé".
			$this->datas['resultat']="Elève ".$this->getId()." non effacé car il y a eu un problème en supprimant les dépendances : ";
		}
		$this->datas['resultat'] .=$del_elvgrp."/".$nbr_elvgrp." groupes, ";
		$this->datas['resultat'] .=$del_rep."/".$nbr_rep." réponses (effacé/trouvé)";

		return $nbr; // nombre d'élèves effacés (normalement 1 ou 0)
	}


}
?>