<?php

class Etablissement extends Modele { 
	
	public $id;
	public $profil;
	

	public function Etablissement($id,$key=null,$rest="GET",$profil=null){ 
		

		parent::__construct('etablissements',$id,'RNE',$rest);



//		attention $id est compris comme (int) varchar RNE
		$this->datas=$this->select();

		//echo $this->datas[0]['RNE'];
		if(count($this->datas)==0){
			exit();
		}

		$rne = $this->datas[0]['RNE'];

		$this->datas['rne']=$rne;


		
		$synchro=$this->selectClasses($rne);
		
		$this->synchroClasses($rne,$synchro);

		$this->selectClasses($rne);


		if($this->getRest()=="DELETE"){
			$force = "force_delete";
			$this->deleteEtablissement($force);
		}


	}

	public function synchroClasses($rne,$synchro){
		$sconet_classes= new Modele("sconet_classes",$rne,"rne");

		$c=$sconet_classes->select();
		foreach($c as $sconet){
			$id=$sconet['classe'].$sconet['rne'];
			if (!isset($synchro[$id])){
				unset($sconet['id']);
				$this->createClasse($sconet);
				$synchro[$id]=$sconet;
			}
		}
		

	}

	public function selectClasses($rne){
		$etabclasses=new Modele("classes",$rne,"rne",null);
		$synchro=array();
		$classes=$etabclasses->select();
		foreach($classes as $classe){
			if($classe['classe'][0]!="_"){
				$id=$classe['id'];
				$this->datas['classes'][$id]=$classe;
				$synchro[$classe['classe'].$rne]=$classe;
			}
			

		}	
		//print_r($synchro);exit();
		return $synchro;
	}

	public function createClasse($classe){
		$new=new Modele("classes");
		$o_classe=(object) $classe;
		$new->save($o_classe);

	}

	

	public function deleteEtablissement($force=""){

		$this->datas=$this->select();
		$rne = "'".$this->datas[0]['RNE']."'";
		$id=(int) $this->datas[0]['RNE'];
//		attention $id est compris comme (int) varchar RNE

		$this->profil = (object) array('role'=>'prof');
//		$profil=$this->profil;


		// On efface en cascade les éléments qui composent cet etablissement (where rne) :
		//  classes 
		//  profs_groupes 
		//  eleves 		-> réponses (where id_eleve) et eleves_groupes (where id_eleve)
		//  affectation -> profs (where id_prof)
		//  profs_reserve

		//  classes 
		$nbr_cls=0; $del_cls=0;
		$etabclasses=new Modele("classes",$rne,"rne",null);
		foreach ($etabclasses->select() as $classe){
			$nbr_cls++;
			$uneclasse=new Classe($classe['id'],"id",null,null);
			$del_cls+=$uneclasse->deleteClasse($force);
		}
		//  profs_groupes 
		$nbr_grp=0; $del_grp=0;
		$prof_groupes=new Modele("profs_groupes",$rne,"rne",null);
		foreach ($prof_groupes->select() as $groupe){
			$nbr_grp++;
			$ungroupe=new Groupes($groupe['id'],"id",null,$this->profil);
			$del_grp+=$ungroupe->supprimeGroupe($force);
		}
		//  eleves 		-> réponses (where id_eleve) et eleves_groupes (where id_eleve)
		$nbr_elv=0; $del_elv=0;
		$eleves=new Modele("eleves",$rne,"rne",null);
		foreach ($eleves->select() as $eleve){
			$nbr_elv++;
			$uneleve=new Eleve($eleve['id'],"id",null,$this->profil);
			$del_elv+=$uneleve->deleteEleve($force);
		}
		//  affectation -> profs (where id_prof)
		$nbr_aff=0; $del_aff=0;
		$affectations=new Modele("affectation",$rne,"rne",null);
		foreach ($affectations->select() as $affectation){
			$nbr_aff++;
			$unprof=new Prof($affectation['id_prof'],"id",null,$this->profil);
			$del_aff+=$unprof->deleteProf($force);
		}
		//  profs_reserve
		$nbr_rsv=0; $del_rsv=0;
		$profs_reserve=new Modele("profs_reserve",$rne,"rne",null);
		foreach ($profs_reserve->select() as $reserve){
			$nbr_rsv++;
			$unreserviste=new Modele("profs_reserve",$reserve['id'],"id",null);
			$unreserviste->setId("'".$reserve['id']."'");
			$del_rsv+=$unreserviste->delete();
		}
		

		$nbr = 0;
		if (($nbr_cls==$del_cls && $nbr_grp==$del_grp && $nbr_elv==$del_elv && $nbr_aff==$del_aff && $nbr_rsv==$del_rsv) || $force=="force_delete") { 
			// on efface l'enregistrement Etablissement
			$nbr = $this->setId($rne)->delete("rne");
			if ($nbr==1) { $this->datas['resultat']="Etablissement ".$rne." bien effacé, dont : ";} 
			else { $this->datas['resultat']="Etablissement ".$rne." NON effacé (problème inconnu), dont : ";}
		} else { 
			// si problème avec l'effacement des éléments enfants on n'efface pas la réponse, à moins d'etre en "forcé".
			$this->datas['resultat']="Etablissement ".$rne." NON effacé, car il y a eu un problème en supprimant les dépendances : ";
		}
		$this->datas['resultat'] .=$del_cls."/".$nbr_cls." classes, ";
		$this->datas['resultat'] .=$del_grp."/".$nbr_grp." profs_groupes, ";
		$this->datas['resultat'] .=$del_elv."/".$nbr_elv." élèves, ";
		$this->datas['resultat'] .=$del_aff."/".$nbr_aff." profs affectés, ";
		$this->datas['resultat'] .=$del_rsv."/".$nbr_rsv." profs réserve (effacé/trouvé)";

		return $nbr; // nombre d'établissements effacés (normalement 1 ou 0)
	}

}
?>