<?php
class Groupes extends Modele { 
	
	

	public $id;
	public $profil;

	public function Groupes($id=null,$key=null,$rest="GET",$profil=null){ 
		
		parent::__construct($profil->role."s_groupes",$id,"id_".$profil->role,$rest);

		$this->datas=array();
		$this->profil=$profil;
		if(isset($this->profil->action)) { if ($this->profil->action=="audit") { 
			$instance=new Modele('profs_groupes',$id);
			$instance->auditTable('profs_groupes','id_prof','profs','id');
			$instance->auditTable('profs_groupes','rne','etablissements','RNE');
		}}
		else
		{
		
		$params=array("champs"=>"id_".$profil->role);
		$this->datas=$this->select($params);
		if($this->getRest()=="POST"){

			$this->datas['method']="POST";
			$this->postDatas=json_decode(file_get_contents("php://input"));
			$this->postDatas->id=$this->getId();
			
			if (isset($this->postDatas->ajouteEleve)) {  // si on trouve un champ "ajouteEleve : " dans les postDatas
				$this->ajouteEleve($this->postDatas->ajouteEleve); 
			}
			elseif (isset($this->postDatas->supprimeEleve)) {
				$this->supprimeEleve($this->postDatas->supprimeEleve); // si on trouve un champ "supprimeEleve : " dans les postDatas
			}
			else {
				$datas=$this->postDatas;
				$datas->id_prof=$profil->id;
				$this->ajouteGroupe($datas);  //sinon c'est qu'on édite ou crée un groupe (attendus : libelle, rne)
			}
			
		}
		elseif($this->getRest()=="DELETE"){
			$force = "";
			if(isset($this->profil->action)) { if ($this->profil->action=="terminator") { $force = "force_delete"; }}
			$this->supprimeGroupe($force);
		}
		
		}	
	}


	public function ajouteGroupe($datas){
		// Crée un nouveau groupe dans profs_groupes (ou renomme si on appelle groupes/id )
		$lien=new Modele("profs_groupes",$this->getId(),"id",null);
		$this->datas['resultat'] = $lien->save($datas);
		//Noe
		$pod_podcast = new Modele("podcast_eleves");
		$datas_podcast = array(	"id_ensemble"=>$this->datas['resultat']['id'],
							"id_prof"=>$this->datas['resultat']['id_prof'],
							"type_ensemble"=>"groupe");
		$datas_podcast['podcast'] = md5(time().$this->datas['resultat']['id_prof'].$this->datas['resultat']['id']);
		$pod_podcast  -> save($datas_podcast);
		//Noe
	}


	public function supprimeGroupe($force=""){
		// supprime un groupe existant dans profs_groupes et dépeuple eleves_groupes (WHERE id_groupe)
		$this->datas=$this->selectById();

		// on efface d'abord tous les liens vers les élèves dans eleves_groupes
		$nbr_elvgrp=0; $del_elvgrp=0;
		$eleves_groupes=new Modele("eleves_groupes",$this->getId(),"id_groupe",null);

		$params['champs']="id_groupe";
		$eleves_grp= $eleves_groupes->select($params);
		$nbr_elvgrp=count($eleves_grp);

		$del_elvgrp+=$eleves_groupes->delete("id_groupe"); // TODO il faudait plutot par id avec une clé unique

		// suppression des partages correspondant au groupe en cours d'effacement
		$nbr_part=0; $del_part=0;
		$partages=new Partage($this->getId(),"id_ensemble",null,"prof");
		foreach ($partages->select() as $partage){
			if ($partage['type_ensemble']=="groupe") {  // attention id_ensemble + type_ensemble=='groupe'
				$nbr_part++;
				$unpartage=new Partage($partage['id'],"id",null,"prof");
				$del_part+=$unpartage->deletePartage($force);
			}
		}

		$nbr = 0;
		if ($nbr_elvgrp==$del_elvgrp && $nbr_part==$del_part || $force=="force_delete") { // alors on efface l'enregistrement profs_groupes
			$nbr = $this->delete();
			$this->datas['resultat'] = $nbr." profs_groupes effacé(s), dont : ";
		} else { 
			// si problème avec l'effacement des eleves_groupes, à moins d'etre en "forcé".
			$this->datas['resultat'] = "Groupe prof ".$this->getId()." non effacé car il y a eu un problème en supprimant les eleves_groupes : ";
		}
		$this->datas['resultat'] .= $del_elvgrp."/".$nbr_elvgrp." eleves_groupes, ";
		$this->datas['resultat'] .=$del_part."/".$nbr_part." partages (effacé/trouvé)";

		return $nbr; // nombre de profs_groupes effacés (normalement 1 ou 0)
	}


	public function ajouteEleve($id_eleve){
		// Crée le lien vers un élève dans eleves_groupes
		$lien=new Modele("eleves_groupes",$this->getId(),"id_groupe",null);
		$id_groupe=$this->getId(); //l'id_groupe est fournie par l'url, sinon dans le postData :
		if ($id_groupe==0) { $id_groupe = $this->postDatas->id_groupe; }

		$datas=array('id_groupe'=>$id_groupe, 'id_eleve' => $id_eleve);
		$this->datas['resultat'] = $lien->save($datas);
	}


	public function supprimeEleve($id_eleve){
		// Supprime le lien vers un élève dans eleves_groupes
		$lien=new Modele("eleves_groupes",$this->getId(),"id_groupe",null);
		$id_groupe=$this->getId(); //l'id_groupe est fournie par l'url, sinon dans le postData :
		if ($id_groupe==0) { $id_groupe = $this->postDatas->id_groupe; }

		$conditions=array("id_groupe"=>$this->getId(),"id_eleve"=>$id_eleve);
		$nbr = $lien->deletecondition($conditions);  // nombre de liens eleves_groupe effacés (normalement 1 ou 0)

		$this->datas['resultat'] = $nbr." eleves_groupes effacée(s).";
	}


}
?>