<?php

class Modele  { 

	/**
	*	Objet PDO
	*	@access private
	*	@var PDO
	*/	
	private $PDO;

	/**
	*	Methode utilisée
	*	@access private
	*	@var string
	*/	
	private $rest;
	
	/**
	*	Table principale gérée par la classe Modele
	*	@access private
	*	@var string
	*/
	private $table;

	/**
	*	Clé primaire courante
	*	@access private
	*	@var integer
	*/	
	private $id = 0; //valeur par défaut : pas d'id

	/**
	*	Clés étrangères gérée par la classe Modele
	*	@access private
	*	@var string
	*/	
	private $key;
	
	/**
	*	Tables secondaires gérée par la classe Modele
	*	@access private
	*	@var string
	*/	
	private $tables;
	
	/**
	*	Listes des champs de la table (TODO à automatiser?)
	*	@access private
	*	@var array[] string
	*/	
	private $fields;
	
	/**
	*	Classes à charger en dépendances
	*	@access private
	*	@var array[] string
	*/	
	private $dependances;


	private $config;

	public $profil;


	/**
	*	Fonction Modele
	*
	*	Constructeur
	*	
	*	@access public
	*	@param string $table 
	*	@param integer $id
	*	@param string $key
	*	@return PDO		
	*/
	public function __construct( $table, $id=0, $key=NULL, $rest='GET' ){ 
		
		$config=new Config();
		
		$this->setTable($table)->setRest($rest)->setId($id)->setKey($key);
		
//utiliser plutot un SETTER ->		isset($key) ? $this->key=$key : $this->key=$this->id;

		try{
			$this->PDO = new PDO('mysql:host='.$config->getDB('host').';port='.$config->getDB('port').';dbname='.$config->getDB('name'), $config->getDB('user'), $config->getDB('password'));
		} catch (PDOException $e){
			$msgErreur = $e->getMessage();
			print( "Erreur ! : ". $msgErreur."<br/>");
			//die();
			return json_encode($msgErreur);
		}	
	}



	/**
	*	Fonction selectById
	*
	*	Pour une id donnée, retourne la tableau associatif Array(champ => valeur) et affecte Modele->champ = valeur
	*	
	*	@access public
	*	@param string $champs = "*" 
	*	@return array		
	*/ 
	public function selectById( $champs = array() ){
		
		$this->setFields($champs);
		$champs = $this->getFields();

		$sql = "SELECT $champs FROM ".$this->table;
		$sql.=" WHERE id=".$this->id;
		
//var_dump($sql); 
		
		$result=array();
		if($req = $this->PDO->query($sql)){
			$dat = $req->fetchAll(PDO::FETCH_ASSOC);
		}
		else return $result;
		

		foreach($dat as $row){	
			foreach($row as $k=>$v){
				if($k=="id"){$id=$v;}
				$result[$k] = utf8_encode($v);
				//$result[$k] = $v;
			}	
		}

		return $result;
	}

	public function sql($sql) {
		$req = $this->PDO->query($sql);
		$dat = $req->fetchAll(PDO::FETCH_ASSOC);
		

		

		return $dat;

	}


	/**
	*	Fonction SELECT
	*
	*	Retourne plusieurs lignes de la base
	*
	* 		Attendus 
	*	$params['champs'] sinon '*'
	*	$params['ordre'] sinon 'id DESC'  (champ de tri et sens)
	*	$params['limite'] sinon ''  (nombre de ligne à retourner...)
	*	$params['offset'] sinon ''  (...à partir de cet offset)
	*	
	*	@access public
	*	@param array $params = array()
	*	@return array
	*/

	public function select( $params = array() ){

		/** @FL | Pas Top : Rend inutile la méthode setFields 
		et nécessite de connaître le nom des paramètres !*/
		$champs = isset($params['champs'])?$params['champs']:"*";
        $this->setFields($champs);
        $champs = $this->getFields();

        /* Mieux à mon avis :

		if( isset($params['champs']) ):
			$champs = isset($params['champs'])?$params['champs']:"*";
        	$this->setFields($champs);
        endif;
        $champs = $this->getFields();

		Permet la chaînage explicite: $this->setFields( Array(...) )->select();
        */

		$sql = "SELECT $champs FROM ".$this->table ;

		if(isset($this->key) and $this->key!=null){
			$sql.=" WHERE ".$this->key."=".$this->id ;
			if(isset($params['key2'])){
				$key2=array_keys($params['key2']);
				//$test=array_keys($params['key2']);
				foreach ($key2 as $cle2){
					$val2=$params['key2'][$cle2];
					$sql.=" and $cle2='$val2' ";

				}
				// $val2=$params['key2'][$key2];
				// $sql.=" and $key2='$val2' ";
				//Modele::__DEBUG__($sql);
			}
		}
		elseif(isset($this->id) and $this->id!=null){
			$sql.=" WHERE id=".$this->id;
		}


		$ordre = ""; //id ou $this->key
		if (! isset( $params['ordre'] ) ) {
			if (isset($this->key) and $this->key!=null) { 
				$ordre = " ORDER BY ";
				$ordre.=$this->key.' desc'; 
			} elseif(isset($this->id) and $this->id!=null) {
				$ordre=' ORDER BY id desc';
			}
		} else {
			$ordre = " ORDER BY ";
			$ordre.=$params['ordre']." desc";
		}
		//

        $limite = (in_array('limite',array_keys($params)))?$limite = " LIMIT ".$params['limite']:'';
        $offset = (in_array('offset',array_keys($params)))?$offset = " OFFSET ".$params['offset']:'';

       
		$sql.= $ordre.$limite.$offset;
		
		Modele::__DEBUG__($sql,1);
		
		$req = $this->PDO->query($sql);

		$dat = $req->fetchAll(PDO::FETCH_ASSOC);

		$results=array();
		$result=array();
		
		$id=0;
		foreach($dat as $row){	
			foreach($row as $k=>$v){

				if($k=="id"){$id=$v;}
				//$result[$k] = utf8_encode($v);
				$result[$k] = $v;

			}

			if( isset($params["ordre"]) or empty($id) ) {	// !isset($id)||!$id
				$results[]=$result;
			} else {
				$results[$id]=$result;
			}
		}

		return $results;
	}


	/**
	*	Fonction SAVE
	*
	*	crée ou met à jour un enregistrement
	*
	* 	Attendus 
	*	tableau $datas dont les clés doivent correspondre à des noms de champs
	*	UPDATE si l'id ou la kid est déjà présente, sinon INSERT INTO
	*	
	*	@access public
	*	@param array $datas = array()	($datas [clé => valeur] , dont une clé est id=... (ou $kid) puis tous les champs
	*	@param string $kid 				(clé étrangère ou id)
	*	@return integer 				(id modifié ou nouvel id créé)
	*/ 

	public function save( $dataObject , $kid = 'id', $deleteId =true ){
		$datas=(array)$dataObject;

		$id = isset($datas[$kid])?$datas[$kid]:0;
		if($deleteId && isset($datas[$kid])) unset($datas[$kid]);
		

		$this->setFields(array_map("addslashes", $datas)); 
		//dans setFields() validation des champs (TODO générer une exception si champ invalide)

		$q="";
		$i=0;
		foreach($this->fields as $k=>$v){
			if($i>0) $q.=", ";
			$q.=$k."='".$v."'";
			$i++;
		}

if (!is_numeric($id)) {$id="'".$id."'";} //pour le cas RNE (etablissements)

		//Modele::__DEBUG__($this->isID( $id , $kid ));
		if( $id and (! $this->isID( $id , $kid ))):  // aucune id
			$id = 0;
		endif;

		if($id) :
			$U = array(); unset( $datas[$kid] );
			foreach( $datas as $cle => $valeur){
				$U[] = $cle." = '".addslashes($valeur)."'";
			}
			$sql = "UPDATE ".$this->table." SET ".$q." WHERE ".$kid."=".$id;		// ! Attention UPDATE multiples possibles ?
		else :	
			$sql = "INSERT INTO ".$this->table." SET ".$q; 
		endif;	

//Modele::__DEBUG__($sql);	
//var_dump($sql);
		try {
			$ret = $this->PDO->exec($sql);
		} catch (PDOException $e) {
			$msgErreur = $e->getMessage();
			print( "Erreur ! : ". $msgErreur."<br/>");
			print( "code : ". (int)$e->getCode()."<br/>");
//			die();
			return json_encode($msgErreur);
		}

		if ($ret) { 	// si resultat de requete true
			$id=$id?$id:$this->PDO->lastInsertId();
			$datas['id']=$id;
			return $datas;
		} else {  		// si resultat false
			if ($ret==0) { 	//update sans modification en base
				return "$ret=0 pour la requete $sql=".$sql;
			} else { 		// erreur sur l'execution de la requete
				var_dump($this->PDO->errorInfo()); //code erreur mysql
				return $sql;	//on retourne la string requête foireuse
			}
		}
    }


	/**
	*	Fonction DELETE
	*
	*	supprime un enregistrement
	*
	*	@access public
	*	@param string $kid 				(clé étrangère ou id)
	*	@return integer 				(nbre de lignes supprimées)
	*/ 

	public function delete( $kid='id' ){
		
		$id=$this->getId();
		//echo $this->isID($id,$kid);exit();
		if ($this->isID($id,$kid)) {
			//ne pas oublier de vérifier les droits (créateur)
		
			$sql = "DELETE FROM ".$this->table." WHERE ".$kid."=".$id;

		}

		try {
			//Modele::__DEBUG__($sql,$this->table);
			$ret = $this->PDO->exec($sql);
		} catch (PDOException $e) {
			$msgErreur = $e->getMessage();
			print( "Erreur ! : ". $msgErreur."<br/>");
			print( "code : ". (int)$e->getCode()."<br/>");
//			die();
			return json_encode($msgErreur);
		}

		// If the query is succesfully performed ($count not false)
		if($ret !== false) {
			return $ret;       // nbre de lignes supprimées.
		} else {
			var_dump($this->PDO->errorInfo()); //code erreur mysql
			return $sql;	//on retourne la string requête
		}

	}


	/**
	*	Fonction DELETECONDITION
	*
	*	supprime un enregistrement dans une table, selon des conditions spécifiées
	*
	*	@access public
	*	@param  $datas = array()	($datas [clé => valeur] sont des champs de la table )
	*	@return integer 				(nbre de lignes supprimées)
	*/ 

	public function deletecondition( $datas=array() ){
		
		$conditions = "1=1";
		foreach ($datas as $champ => $valeur) {
			$conditions.=" AND ".$champ."=".$valeur;
		}

		$sql = "DELETE FROM ".$this->table." WHERE ".$conditions;
//var_dump($sql);

		try {
			//Modele::__DEBUG__($sql,$this->table);
			$ret = $this->PDO->exec($sql);
		} catch (PDOException $e) {
			$msgErreur = $e->getMessage();
			print( "Erreur ! : ". $msgErreur."<br/>");
			print( "code : ". (int)$e->getCode()."<br/>");
//			die();
			return json_encode($msgErreur);
		}

		// If the query is succesfully performed ($count not false)
		if($ret !== false) {
			return $ret;       // nbre de lignes supprimées.
		} else {
			var_dump($this->PDO->errorInfo()); //code erreur mysql
			return $sql;	//on retourne la string requête
		}

	}


    /**
	*	Fonction isID
	*
	*	Teste l'existence d'un ID
	*
	*	@access public
	*	@param string $id = 'id' (nom de la clé primaire)
	*	@param string $table
	*	@return integer 		nombre de réponses (boolean si on veut)
	*/ 
    public function isID( $id, $kid = 'id' ){

		$sql = "SELECT COUNT(*) as nb FROM ".$this->table." WHERE ".$kid."=".$id;
		
		//echo($sql);exit();
		//modele::__DEBUG__($sql);
		$result = $this->PDO->query($sql);
//		$found = ($result->fetchColumn() > 0) ? true : false;

		$reponses = $result->fetchAll();
		
		
		$found = $reponses[0]['nb'];
		
		return $found;
	}



	/*************************
	*	Fonction setId
	*
	*	Réaffectation et retourne l'élément identifié par $id
	*	
	*	@access public
	*	@param integer $id 
	*	@return 
	* ??????????????????? LE TEST 		
	*/ 
	public function setId($id){

		if (is_numeric($id) && $id>0) {	
			$this->id = (integer) $id;
		} 
		elseif ($id==''){
			$this->id=0;
		}
		else{
			 
			str_replace('"', "", $id);
			str_replace("'", "", $id);
			$this->id = "'".$id."'";
			
		}
		return $this;
	}

	/*************************
	*	Fonction getId
	*
	*	Retourne $id d'un objet
	*	
	*	@access public
	*	@return integer
	*/ 
	public function getId(){
		return $this->id;
	}


	/*************************
	*	Fonction setTable
	*
	*	Affectation de $table, retourne l'objet
	*	
	*	@access public
	*	@param string $table
	*	@return object
	*/ 
	public function setTable($table){
		if (isset($table)) 					//est-ce que la table existe dans la base ? structure information_schema.columns
											//SELECT TABLE_NAME FROM <DATABASE_NAME>.INFORMATION_SCHEMA.Tables
		{	$this->table = $table;
		} else {
			$this->table = NULL;
		}
		return $this;	
	}

	/*************************
	*	Fonction getTable
	*
	*	Retourne la $table courante d'un objet
	*	
	*	@access public
	*	@return string
	*/ 
	public function getTable(){
		return $this->table;
	}


	/*************************
	*	Fonction setTables
	*
	*	Affectation de $tables, retourne l'objet
	*	
	*	@access public
	*	@param array $tables = array()
	*	@return object
	*/ 
	public function setTables( $tables ) {

		if (is_array($tables) && count($tables)>0){
			$this->tables = array();
			$touteslestables = $this->showTables(); 	//toutes les tables de la db

			foreach ($tables as $k => $v) {	
				if (in_array($k, $touteslestables)) { 	//On remplit seulement avec les tables valables
					$this->tables[$k] = $v;
				}
			}
		}
		else {	// rien ou NULL ...
			$this->tables = array();		// plutot un tableau vide que NULL
		}
		return $this;
	}

	/*************************
	*	Fonction getTables
	*
	*	Retourne une chaine à partir de l'array des $tables secondaires associees à l'objet
	*	
	*	@access public
	*	@return string
	*/ 
	public function getTables(){
		return implode(',' , $this->tables);
	}


	/*************************
	*	Fonction setKey
	*
	*	Affectation de $key, retourne l'objet
	*	
	*	@access public
	*	@param string $key
	*	@return object
	*/ 
	public function setKey($key){
		if (isset($key))
		{	$this->key = $key;
		} else {
			$this->key = NULL;
		}
		return $this;	
	}

	/*************************
	*	Fonction getKey
	*
	*	Retourne $key d'un objet
	*	
	*	@access public
	*	@return string
	*/ 
	public function getKey(){
		return $this->key;
	}


	/*************************
	*	Fonction setRest
	*
	*	Affectation de $rest, retourne l'objet
	*	
	*	@access public
	*	@param string $rest
	*	@return object		
	*/ 
	public function setRest( $rest ){
		$rest=strtoupper($rest);

		switch ($rest) {
			case 'GET':
			case 'PUT':
			case 'POST':
			case 'DELETE':
				$this->rest = $rest;
				break;
			default :
				$this->rest = NULL;
				break;
		}

		return $this;	
	}

	/*************************
	*	Fonction getRest
	*
	*	Retourne $rest d'un objet
	*	
	*	@access public
	*	@return string
	*/ 
	public function getRest(){
		return $this->rest;
	}


	/*************************
	*	Fonction setFields
	*
	*	Affectation des $fields dans un tableau, retourne l'objet
	*	$fields est un tableau associatif : { 'text'=>'texte', 'id_prof'=>'identifiant' ...}
	*			ou la chaîne '*'
	*	
	*	@access public
	*	@param array $fields = array()
	*	@return object		
	*/ 
	public function setFields( $fields = array() ){

		if (is_array($fields) && count($fields)>0){
			$this->fields=array();
			//On remplit avec les champs valables
			foreach ($fields as $k => $v) {	
				if ( $this->structure($this->table, $k) ) { //TODO vérifier que les champs existent dans la table (structure)
					$this->fields[$k] = $v;
				}
				// else générer une exception si un champ est invalide
			}
		}
		else {	// rien ou NULL ou chaine '*'...
			$this->fields = array();		// plutot un tableau vide que NULL
		}
		return $this;	
	}

	/*************************
	*	Fonction getFields
	*
	*	Retourne une chaîne à partir de l'array $fields d'un objet
	*	
	*	@access public
	*	@return string
	*/ 
	public function getFields(){
		if (is_array($this->fields) && count($this->fields)>0) {
			$champs = implode(",", $this->fields);
		}
		else {
			$champs = "*";
		}
		return $champs;
	}



	/*************************
	*	Fonction auditTable et existe
	*
	*	on parcourt une $table en vérifiant pour chaque entrée
	*	si la valeur du champ $key existe dans la table $tablien en tant que champ $keylien

	*	Teste la présence d'un enregistrement valide pour la clé étrangère spécifiée
	*	fonction destinée à auditer la base et détecter d'éventuelles orphelines
	*
	*	@access public
	*	@param $key le champ
	*	@param $kid
	*	@return boolean
	*/
	public function existe($key, $kid){
		$champs = array( $key => $kid );
    	return (boolean) $this->select($champs);
	}

	public function auditTable($table, $key, $tablien, $keylien){

		$nbr_total=0; $nbr_true=0; //$orphelines=array();
		foreach ($this->select() as $elements) {
			$nbr_total++;
			$elem_lien=new Modele($tablien,$elements[$key], $keylien, null);
			$result = $elem_lien->existe($elements[$key], $keylien);
			if ($result) { 
				$nbr_true++;
			} else { 
		//		$orphelines[$elements['id']] = $elements['id_prof'];
				if (isset($elements['id'])) {$numero=" id=".$elements['id'];} else { $numero=" ";}
		    	file_put_contents("logs/audit.txt", $table."".$numero." possede un ".$key."=".$elements[$key]." inconnu.\n", FILE_APPEND);
			}
		}
		$msg = "OK"; if (($warnings=$nbr_total-$nbr_true) > 0) { $msg = "= ".$warnings." orpheline(s)" ; }
		//$nomclasse = new ReflectionClass($this); pour récupérer le nom de la classe courante : $nomclasse->getShortName()

		file_put_contents("logs/audit.txt", "Bilan AUDIT : ".$nbr_total." '".$table."' (".$key.") -> ".$nbr_true. " '".$tablien."' (".$keylien.") ".$msg."\n", FILE_APPEND);
		file_put_contents("logs/audit.txt", "-----------\n", FILE_APPEND);
		// return $orphelines;
	}


	/*************************
	*	Fonction structure
	*
	*	retourne si l'élément donné en paramètre existe dans la database (table ou table/column)
	*/

	/* @FL : 
		public function getStructure(){
			$sql = "SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE table_name = '". $this->getTable() ."'";
			$query = $this->getPDO()->query($sql);
			$data = $query->fetchAll(PDO::FETCH_ASSOC);
			return $data;
		}
	*/
	
	/// TODO faire une méthode qui remplit les champs existants une fois pour toutes
	public function structure() {
		return true;
	}



	/*************************
	*	Fonction setDependances
	*
	*	Affectation de $dependances, retourne l'objet
	*	
	*	@access public
	*	@param array $dependances = array()
	*	@return object		
	*/ 
	public function setDependances($dependances){			//test de fichier
		if (isset($dependances))
		{	$this->dependances = $dependances;
		} else {
			$this->dependances = NULL;
		}
		return $this;	
	}

	/*************************
	*	Fonction getDependances
	*
	*	Retourne $dependances d'un objet
	*	
	*	@access public
	*	@return string
	*/ 
	public function getDependances(){
		return $this->dependances;
	}

		////  faire une méthode chargeDependances ici ?

/*  ex. dans setReponse() du modele Consigne :
				Modele::charge('reponse');
				$this->reponse=new Reponse($this->id)
				return $this->reponse ou $this ? (consigne)
*/


	/*************************
	*	Fonction showTables
	*
	*	Renvoie une liste des tables de la base
	*	
	*	@access public
	*	@return array
	*/ 
	public function showTables(){

		function lestables($nomdestables) {
		  return $nomdestables;
		}
		$result = $this->PDO->query("show tables");
		$ar_row = $result->fetchAll(PDO::FETCH_FUNC, 'lestables');       // FETCH_FUNC applique lestables()
		//var_export($ar_row);
		return($ar_row);
	}



	/*************************
	*	Fonction charge
	*
	*	Chargement d'un modèle hérité
	*
	*	@access static
	*	@param string $name
	*	@return object Modele 
	*/
 	// 
    static function charge( $name ){ 
        require_once("include/$name.php");
        return new $name();
    }


	/*************************
	*	Fonction __DEBUG__
	*
	*	Affichage de données de tous types si debuggage
	*
	*	@access static
	*	@param integer|float|string|array|object $var
	*	@param boolean $debug = true 
	*/
	static function __DEBUG__($txt,$a=false){
		if(is_array($txt)|| is_object($txt))
		{
			$txt=json_encode($txt);
		}
		if($a==10){
			file_put_contents("logs/log.txt", $txt."\n", FILE_APPEND);
		}
    	
	
	}


	static function encode($val){
		if(!preg_match('!!u', $val)){
		//if (mb_detect_encoding($val , 'UTF-8', true) === false){
			//Modele::__DEBUG__("pas UTF8 : ".utf8_encode($val));				
			return htmlentities(utf8_encode($val,ENT_QUOTES));	
		}
		else{
			//Modele::__DEBUG__("UTF8 : ".$val);
			return htmlentities($val,ENT_QUOTES);
		}
	}
// transformation du log pour générer des requetes sql appliquées à la main sur le vieux balado)
/*	static function __DEBUG__($txt,$table=null){
     	switch ($table){
     		case 'partages': $txt=str_replace("WHERE id=","WHERE id_part=",$txt); break;
     		case 'consignes': $txt=str_replace("WHERE id=","WHERE id_consigne=",$txt); break;
     		case 'profs_media': $txt=str_replace("WHERE id=","WHERE id_media=",$txt); break;
     		case 'profs_uploads': $txt=str_replace("WHERE id=","WHERE id_upload=",$txt); break;
     		case 'reponses': $txt=str_replace("WHERE id=","WHERE id_reponse=",$txt); break;
     		case 'eleves_media': $txt=str_replace("WHERE id=","WHERE id_media=",$txt); break;
     		case 'eleves_uploads': $txt=str_replace("WHERE id=","WHERE id_upload=",$txt); break;
     	}
    	file_put_contents("logs/log.txt", $txt.";\n", FILE_APPEND);
*/

}

?>
