<?php
class Consigne extends Modele { 
	
	public $id;
	public $params;
	public $profil;
	public $format;

	public function Consigne($id=0,$key=NULL,$rest='GET',$profil=NULL,$format="complet"){ 
		
		parent::__construct('consignes',$id,$key=NULL,$rest);
		$this->format=$format;
		$this->profil=$profil;
		$this->datas=$this->selectById();

		if(isset($this->profil->action)) { if ($this->profil->action=="audit") { $this->auditTable('consignes','id_prof','profs','id');	}}

		if($this->droits() && $this->getRest()=="POST"){
			$this->postData=json_decode(file_get_contents("php://input"));
			$this->postData->titre=utf8_decode($this->postData->titre);
			$this->saveConsigne();
		}
		elseif($this->droits() && $this->getRest()=="DELETE"){
			$force = "";
			if(isset($this->profil->action)) { if ($this->profil->action=="terminator") { $force = "force_delete"; }}
			
			$this->deleteConsigne($force);
		}
		elseif($this->droits()){
				
				$partages=new Partages($this->getId(),"id_consigne");
				

				if($this->format=="complet"){
					$this->datas['partages']=$partages->datas;
					$uploads=new Modele("profs_uploads",$this->getId(),"id_consigne");
					
					foreach ($uploads->select() as $upload){
						$unupload=new Upload($upload['id'],"id","GET",$profil,"profs_uploads");
						$this->datas['uploads'][]=$unupload->datas;
					}
				
				
					$medias=new Modele("profs_media",$this->getId(),"id_consigne");
					foreach ($medias->select() as $media){
						$unmedia=new Media($media['id'],"id","GET",$profil,"profs_media");
						$this->datas['medias'][]=$unmedia->datas;
					}
					
					$reponses=new Reponses($this->getId(),$key,$rest,$profil);
					$this->datas['reponses']=$reponses->datas;
				}
				elseif($this->format=="decompte"){
					//$reponses=new Reponses($this->getId(),$key,$rest,$profil);
					
					
					
					$this->datas['partages']=$partages->datas;
					
					//$this->datas['reponses']=$reponses->datas;
					//$eleves=new Eleves($this->getId(),$key,$rest,$profil);
					
				}
				
			}
		else{
			$this->datas="acces interdit";
		}
	
	}

	public function saveConsigne(){
		
		$result=$this->save($this->postData);
		$this->datas['resultat']=$result;
		
	}


	public function droits(){
		$acces=(isset($_GET['debug']))?true:false;

		if($this->profil->role=="prof" || $this->profil->role=="gest"){
			if($this->datas){
				if(isset($this->profil->id)) { 
					if($this->profil->id==$this->datas['id_prof'] || $this->profil->id==1){
						$acces=true;	
					}
					else{
						$acces=false;
					}
				}
			}
			else{
				$acces=true;
			}
			
		}
		if(isset($this->profil->action)) { if ($this->profil->action=="terminator") { $acces=true; } } 
		return $acces;
	}

	public function deleteConsigne($force=""){

		// On efface les éléments qui référencent cette consigne :
		//  profs_upload
		//  profs_medias
		//  partages
		//  réponses 

		$id_consigne=$this->getId();
		//echo("Effacement de la consigne...".$id_consigne);

		//  profs_upload
		$nbr_up=0; $del_up=0;
		$uploads=new Modele("profs_uploads",$id_consigne,"id_consigne");
		foreach ($uploads->select() as $upload){
			$nbr_up++;
			$unupload=new Upload($upload['id'],"id",null,null,"profs_uploads");
			$del_up+=$unupload->deleteUpload($force);
		}
		//  profs_medias
		$nbr_med=0; $del_med=0;
		$medias=new Modele("profs_media",$id_consigne,"id_consigne");
		foreach ($medias->select() as $media){
			$nbr_med++;
			$unmedia=new Media($media['id'],"id",null,null,"profs_media");
			$del_med+=$unmedia->deleteMedia($force);
		}
		//  partages
		$nbr_part=0; $del_part=0;
		$partages=new Modele("partages",$id_consigne,"id_consigne");
		foreach ($partages->select() as $partage){
			$nbr_part++;
			$unpartage=new Partage($partage['id'],"id",null,$this->profil->role);
			$del_part+=$unpartage->deletePartage($force);
		}
		//  réponses 
		$nbr_rep=0; $del_rep=0;
		$reponses=new Modele("reponses",$id_consigne,"id_consigne");
		foreach ($reponses->select() as $reponse){
			$nbr_rep++;
			$unereponse=new Reponse($reponse['id'],"id",null,$this->profil->role);
			//$del_rep+=$unereponse->deleteReponse($force);
		}


		$nbr = 0;
		if ( ($nbr_rep==0 && $nbr_up==$del_up && $nbr_med==$del_med && $nbr_part==$del_part) || $force=="force_delete") { 
			// on efface l'enregistrement Consigne
			$nbr = $this->delete(); 
			$this->datas['resultat']=$nbr." consigne(s) effacée(s), dont :";
		} else { 
			// si problème avec l'effacement des fichiers upload ou media on n'efface pas la réponse, à moins d'etre en "forcé".
			$this->datas['resultat']="Consigne ".$id_consigne." non effacée car il y a eu un problème en supprimant les dépendances : ";
			
			// $postDatas=array("id"=>$this->datas['id'],"archive"=>1);
			// $this->save($postDatas);
		}
		$this->datas['resultat'] .=$del_up."/".$nbr_up." uploads, ";
		$this->datas['resultat'] .=$del_med."/".$nbr_med." medias, ";
		$this->datas['resultat'] .=$del_rep."/".$nbr_rep." reponses, ";
		$this->datas['resultat'] .=$del_part."/".$nbr_part." partages (effacé/trouvé)";

		return $nbr; // nombre de consignes effacées (normalement 1 ou 0)
	}

}
?>